
# ConnectionDto

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**connectionId** | **String** | The unique ID of the connection |  [optional]
**created** | [**DateTime**](DateTime.md) | When the connection was created, as a datetime |  [optional]
**createdBy** | **String** | The ID of the user that created the connection |  [optional]
**description** | **String** | The description of the connection, if specified |  [optional]
**destinationId** | **String** | The ID of the file or item the connection sends data to |  [optional]
**destinationType** | [**DestinationTypeEnum**](#DestinationTypeEnum) | The type of file or item the connection sends data to |  [optional]
**lastRunBy** | **String** | The ID of the user that last ran the connection |  [optional]
**lastRunDate** | [**DateTime**](DateTime.md) | When the connection last ran, as a datetime |  [optional]
**lastRunDestinationParameters** | **Map&lt;String, Object&gt;** | A map of the parameters used with the destination when the connection last ran |  [optional]
**lastRunJobId** | **String** | The ID of the connection&#39;s last run |  [optional]
**lastRunSourceParameters** | **Map&lt;String, Object&gt;** | A map of the parameters used with the source when the connection last ran |  [optional]
**metadata** | **Map&lt;String, Object&gt;** | Any additional information about the connection |  [optional]
**name** | **String** | The name of the connection, if specified |  [optional]
**sourceId** | **String** | The ID of the file or item the connection pulls data from |  [optional]
**sourceType** | [**SourceTypeEnum**](#SourceTypeEnum) | The type of file or item the connection pulls data from |  [optional]


<a name="DestinationTypeEnum"></a>
## Enum: DestinationTypeEnum
Name | Value
---- | -----
SPREADSHEET | &quot;spreadsheet&quot;
SPREADSHEET_SECTION | &quot;spreadsheet_section&quot;
PRESENTATION | &quot;presentation&quot;
PRESENTATION_CHART | &quot;presentation_chart&quot;
PRESENTATION_EMBEDDED_TABLE | &quot;presentation_embedded_table&quot;
DOCUMENT | &quot;document&quot;
DOCUMENT_CHART | &quot;document_chart&quot;
DOCUMENT_EMBEDDED_TABLE | &quot;document_embedded_table&quot;
WDATA_QUERY | &quot;wdata_query&quot;
WDATA_TABLE | &quot;wdata_table&quot;
WDATA_TABLE_DATASET | &quot;wdata_table_dataset&quot;
REPORT | &quot;report&quot;
UNKNOWN_RECORD_TYPE | &quot;unknown_record_type&quot;


<a name="SourceTypeEnum"></a>
## Enum: SourceTypeEnum
Name | Value
---- | -----
SPREADSHEET | &quot;spreadsheet&quot;
SPREADSHEET_SECTION | &quot;spreadsheet_section&quot;
PRESENTATION | &quot;presentation&quot;
PRESENTATION_CHART | &quot;presentation_chart&quot;
PRESENTATION_EMBEDDED_TABLE | &quot;presentation_embedded_table&quot;
DOCUMENT | &quot;document&quot;
DOCUMENT_CHART | &quot;document_chart&quot;
DOCUMENT_EMBEDDED_TABLE | &quot;document_embedded_table&quot;
WDATA_QUERY | &quot;wdata_query&quot;
WDATA_TABLE | &quot;wdata_table&quot;
WDATA_TABLE_DATASET | &quot;wdata_table_dataset&quot;
REPORT | &quot;report&quot;
UNKNOWN_RECORD_TYPE | &quot;unknown_record_type&quot;



