# FileManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteFileUsingDELETE**](FileManagementApi.md#deleteFileUsingDELETE) | **DELETE** /api/v1/file/{fileId} | Delete a single file
[**downloadFileUsingGET**](FileManagementApi.md#downloadFileUsingGET) | **GET** /api/v1/file/{fileId}/download | Download a single file
[**exportFileToSpreadsheetsUsingPOST**](FileManagementApi.md#exportFileToSpreadsheetsUsingPOST) | **POST** /api/v1/file/{fileId}/export | Export a file to spreadsheets
[**getErrorsUsingGET**](FileManagementApi.md#getErrorsUsingGET) | **GET** /api/v1/file/{fileId}/error | Retrieve errors
[**getFileUsingGET**](FileManagementApi.md#getFileUsingGET) | **GET** /api/v1/file/{fileId} | Retrieve a single file
[**getFilesUsingGET**](FileManagementApi.md#getFilesUsingGET) | **GET** /api/v1/file | Retrieve a list of files
[**uploadFileUsingPOST**](FileManagementApi.md#uploadFileUsingPOST) | **POST** /api/v1/file | Upload a single file
[**validateFilenameUsingGET**](FileManagementApi.md#validateFilenameUsingGET) | **GET** /api/v1/file/validateName | Validate whether a file with the filename can be uploaded to the table


<a name="deleteFileUsingDELETE"></a>
# **deleteFileUsingDELETE**
> BaseResponseOfstring deleteFileUsingDELETE(fileId)

Delete a single file

Unstages the file with the provided ID. The file must have a STAGED status; if the file isn&#39;t STAGED, returns a 409 status. If the file isn&#39;t found, this is a no-op.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FileManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FileManagementApi apiInstance = new FileManagementApi();
String fileId = "fileId_example"; // String | The unique identifier of the file
try {
    BaseResponseOfstring result = apiInstance.deleteFileUsingDELETE(fileId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileManagementApi#deleteFileUsingDELETE");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileId** | **String**| The unique identifier of the file |

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="downloadFileUsingGET"></a>
# **downloadFileUsingGET**
> byte[] downloadFileUsingGET(fileId)

Download a single file

Returns a file with the provided ID, which points to a file meta ID.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FileManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FileManagementApi apiInstance = new FileManagementApi();
String fileId = "fileId_example"; // String | The unique identifier of the file
try {
    byte[] result = apiInstance.downloadFileUsingGET(fileId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileManagementApi#downloadFileUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileId** | **String**| The unique identifier of the file |

### Return type

**byte[]**

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

<a name="exportFileToSpreadsheetsUsingPOST"></a>
# **exportFileToSpreadsheetsUsingPOST**
> BaseResponseOfSpreadsheetInfoDto exportFileToSpreadsheetsUsingPOST(fileId, exportFileDto)

Export a file to spreadsheets

Exports the file ID identified in the path to the spreadsheet identified by the provided URL. If the URL string is empty, creates and returns a new spreadsheet and its sheet IDs.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FileManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FileManagementApi apiInstance = new FileManagementApi();
String fileId = "fileId_example"; // String | The unique identifier of the file
ExportFileDto exportFileDto = new ExportFileDto(); // ExportFileDto | The representation of the file to export
try {
    BaseResponseOfSpreadsheetInfoDto result = apiInstance.exportFileToSpreadsheetsUsingPOST(fileId, exportFileDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileManagementApi#exportFileToSpreadsheetsUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileId** | **String**| The unique identifier of the file |
 **exportFileDto** | [**ExportFileDto**](ExportFileDto.md)| The representation of the file to export | [optional]

### Return type

[**BaseResponseOfSpreadsheetInfoDto**](BaseResponseOfSpreadsheetInfoDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getErrorsUsingGET"></a>
# **getErrorsUsingGET**
> PagedResponseOfImportErrorDto getErrorsUsingGET(fileId, limit, cursor, offset)

Retrieve errors

Returns a paged list of operation errors during the upload, import, or tagging processes for the provided file ID, if they exist. This list is immutable and may be empty if no errors have occurred. If errors exist we recommend fixing them and reimporting your file

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FileManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FileManagementApi apiInstance = new FileManagementApi();
String fileId = "fileId_example"; // String | The unique identifier of the file
Integer limit = 56; // Integer | The number of errors to return, from 1 to 50; by default, 50
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfImportErrorDto result = apiInstance.getErrorsUsingGET(fileId, limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileManagementApi#getErrorsUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileId** | **String**| The unique identifier of the file |
 **limit** | **Integer**| The number of errors to return, from 1 to 50; by default, 50 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfImportErrorDto**](PagedResponseOfImportErrorDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getFileUsingGET"></a>
# **getFileUsingGET**
> BaseResponseOfFileMetaDto getFileUsingGET(fileId)

Retrieve a single file

Returns the file meta that matches the provided ID, or a 404 if an associated file can&#39;t be found.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FileManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FileManagementApi apiInstance = new FileManagementApi();
String fileId = "fileId_example"; // String | The unique identifier of the file
try {
    BaseResponseOfFileMetaDto result = apiInstance.getFileUsingGET(fileId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileManagementApi#getFileUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileId** | **String**| The unique identifier of the file |

### Return type

[**BaseResponseOfFileMetaDto**](BaseResponseOfFileMetaDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getFilesUsingGET"></a>
# **getFilesUsingGET**
> PagedResponseOfFileMetaDto getFilesUsingGET(tableId, limit, cursor, offset, sortOrder, sortBy, searchText)

Retrieve a list of files

Returns a paged list of all files associated with the provided table ID, as well as metadata associated with each file.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FileManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FileManagementApi apiInstance = new FileManagementApi();
String tableId = "tableId_example"; // String | The unique table identifier associated with this file
Integer limit = 56; // Integer | The number of files to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
String sortOrder = "sortOrder_example"; // String | The sort order for the files being returned
String sortBy = "sortBy_example"; // String | The column to use the sort order on
String searchText = "searchText_example"; // String | The text to filter the results upon; matching the file name
try {
    PagedResponseOfFileMetaDto result = apiInstance.getFilesUsingGET(tableId, limit, cursor, offset, sortOrder, sortBy, searchText);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileManagementApi#getFilesUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tableId** | **String**| The unique table identifier associated with this file |
 **limit** | **Integer**| The number of files to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]
 **sortOrder** | **String**| The sort order for the files being returned | [optional] [enum: [asc, desc]]
 **sortBy** | **String**| The column to use the sort order on | [optional] [enum: [name, date]]
 **searchText** | **String**| The text to filter the results upon; matching the file name | [optional]

### Return type

[**PagedResponseOfFileMetaDto**](PagedResponseOfFileMetaDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="uploadFileUsingPOST"></a>
# **uploadFileUsingPOST**
> BaseResponseOfFileMetaDto uploadFileUsingPOST(tableId, file, name, url, source, delimiter)

Upload a single file

Accepts CSV, TSV, or JSON files, or a ZIP file that contains a single CSV, TSV, or JSON file. If a ZIP, it must contain a CSV, TSV, or JSON file, and the name of the CSV, TSV, or JSON file is also used with the imported file. Downloading this file again downloads the source. Note that all files uploaded must have a .csv, .tsv, or .json extension. JSON files are expected to have a single JSON record per line; a JSON file is a series of JSON objects delimited by a newline character.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FileManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FileManagementApi apiInstance = new FileManagementApi();
String tableId = "tableId_example"; // String | The unique table identifier associated with this file
File file = new File("/path/to/file.txt"); // File | The physical file to upload
String name = "name_example"; // String | No longer in use, here to ensure backwards compatibility
String url = "url_example"; // String | No longer in use, here to ensure backwards compatibility
String source = "source_example"; // String | The data source to associate with the file, no more than 255 characters. This field is not in use; it only keeps track of the source
String delimiter = "delimiter_example"; // String | The character to use as a delimiter within the file to separate one field from another.  The default is comma
try {
    BaseResponseOfFileMetaDto result = apiInstance.uploadFileUsingPOST(tableId, file, name, url, source, delimiter);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileManagementApi#uploadFileUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tableId** | **String**| The unique table identifier associated with this file |
 **file** | **File**| The physical file to upload | [optional]
 **name** | **String**| No longer in use, here to ensure backwards compatibility | [optional]
 **url** | **String**| No longer in use, here to ensure backwards compatibility | [optional]
 **source** | **String**| The data source to associate with the file, no more than 255 characters. This field is not in use; it only keeps track of the source | [optional]
 **delimiter** | **String**| The character to use as a delimiter within the file to separate one field from another.  The default is comma | [optional]

### Return type

[**BaseResponseOfFileMetaDto**](BaseResponseOfFileMetaDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

<a name="validateFilenameUsingGET"></a>
# **validateFilenameUsingGET**
> BaseResponseOfstring validateFilenameUsingGET(tableId, filename)

Validate whether a file with the filename can be uploaded to the table

If the filename is valid, this returns 200. If the table already has a file with the same name, this returns 409. If the user isn&#39;t allowed to read the table, or if the table isn&#39;t found, this returns 404.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FileManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FileManagementApi apiInstance = new FileManagementApi();
String tableId = "tableId_example"; // String | The ID of the table to upload the file to
String filename = "filename_example"; // String | The name of the file to upload
try {
    BaseResponseOfstring result = apiInstance.validateFilenameUsingGET(tableId, filename);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileManagementApi#validateFilenameUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tableId** | **String**| The ID of the table to upload the file to |
 **filename** | **String**| The name of the file to upload |

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

