
# FileMetaDto

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**columnMappings** | **Map&lt;String, String&gt;** | Maps the columns in the physical file (CSV or JSON) to the columns in fact table &#x3D; {\&quot;physical_col1\&quot;:\&quot;table_col1\&quot;, \&quot;physical_col2\&quot;:\&quot;table_col2\&quot;} |  [optional]
**created** | [**DateTime**](DateTime.md) | When the entity was created |  [optional]
**delimiter** | **String** | The character to use as a delimiter within the file to separate one field from another.  The default is comma |  [optional]
**id** | **String** | The entity&#39;s unique identifier |  [optional]
**key** | **String** | The key is here for backwards compatibility only and will always be an empty string. |  [optional]
**metadata** | [**Map&lt;String, Map&lt;String, Object&gt;&gt;**](Map.md) | The file&#39;s meta data |  [optional]
**name** | **String** | The name of the file |  [optional]
**numErrors** | **Long** | Number of errors found in the file |  [optional]
**numRecords** | **Long** | Number of records imported from this file.  This will only be non-zero if the file is in the IMPORTED status. |  [optional]
**originalFileSize** | **Long** | Size of the original file that was uploaded. |  [optional]
**source** | **String** | URI that describes the source location of this file if imported from another system. For instance, this will have a spreadsheet URL if this file was imported from spreadsheets. This will be null if the file was uploaded using the data prep API. |  [optional]
**status** | [**StatusEnum**](#StatusEnum) | The files&#39;s current status |  [optional]
**tableId** | **String** | The unique identifier for the table |  [optional]
**tags** | **Map&lt;String, String&gt;** | The tags associated with the file |  [optional]
**updated** | [**DateTime**](DateTime.md) | When the entity was last updated |  [optional]
**userId** | **String** | The owner of the entity |  [optional]
**version** | **Long** | The version of the current representation of the entity |  [optional]


<a name="StatusEnum"></a>
## Enum: StatusEnum
Name | Value
---- | -----
STAGING | &quot;STAGING&quot;
STAGED | &quot;STAGED&quot;
IMPORTING | &quot;IMPORTING&quot;
IMPORTED | &quot;IMPORTED&quot;
ERROR | &quot;ERROR&quot;



