# PivotViewManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createPivotViewUsingPOST**](PivotViewManagementApi.md#createPivotViewUsingPOST) | **POST** /api/v1/pivotview | Create a new pivot view
[**deletePivotViewUsingDELETE**](PivotViewManagementApi.md#deletePivotViewUsingDELETE) | **DELETE** /api/v1/pivotview/{pivotViewId} | Delete a single pivot view
[**downloadPivotViewTokenUsingGET**](PivotViewManagementApi.md#downloadPivotViewTokenUsingGET) | **GET** /api/v1/pivotview/{pivotViewId}/token | This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
[**downloadPivotViewUsingGET**](PivotViewManagementApi.md#downloadPivotViewUsingGET) | **GET** /api/v1/pivotview/{pivotViewId}/download | This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
[**getPivotViewUsingGET**](PivotViewManagementApi.md#getPivotViewUsingGET) | **GET** /api/v1/pivotview/{pivotViewId} | Retrieve a single pivot view
[**listPivotViewsUsingGET**](PivotViewManagementApi.md#listPivotViewsUsingGET) | **GET** /api/v1/pivotview | Retrieve a list of pivot views
[**updatePivotViewUsingPUT**](PivotViewManagementApi.md#updatePivotViewUsingPUT) | **PUT** /api/v1/pivotview/{pivotViewId} | Update a single pivot view


<a name="createPivotViewUsingPOST"></a>
# **createPivotViewUsingPOST**
> BaseResponseOfPivotViewDto createPivotViewUsingPOST(pivotViewDto)

Create a new pivot view

Creates a view from the provided information. Currently, persists the provided &#x60;additionalMetadata&#x60; field, which can store an arbitrary JSON definition of a pivot table view. This pivot table must be associated with a query, and can optionally be associated with a query result. When a query is deleted, its associated views are also deleted.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.PivotViewManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

PivotViewManagementApi apiInstance = new PivotViewManagementApi();
PivotViewDto pivotViewDto = new PivotViewDto(); // PivotViewDto | The representation of the view to create
try {
    BaseResponseOfPivotViewDto result = apiInstance.createPivotViewUsingPOST(pivotViewDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling PivotViewManagementApi#createPivotViewUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewDto** | [**PivotViewDto**](PivotViewDto.md)| The representation of the view to create | [optional]

### Return type

[**BaseResponseOfPivotViewDto**](BaseResponseOfPivotViewDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="deletePivotViewUsingDELETE"></a>
# **deletePivotViewUsingDELETE**
> BaseResponseOfstring deletePivotViewUsingDELETE(pivotViewId)

Delete a single pivot view

Deletes a view that matches the provided ID.  This is an administrative method and should be assumed a hard-delete, given no capability to restore a deleted view is available.  A no-op if no such view exists.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.PivotViewManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

PivotViewManagementApi apiInstance = new PivotViewManagementApi();
String pivotViewId = "pivotViewId_example"; // String | The unique identifier of the pivot view
try {
    BaseResponseOfstring result = apiInstance.deletePivotViewUsingDELETE(pivotViewId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling PivotViewManagementApi#deletePivotViewUsingDELETE");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewId** | **String**| The unique identifier of the pivot view |

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="downloadPivotViewTokenUsingGET"></a>
# **downloadPivotViewTokenUsingGET**
> BaseResponseOfTokenDto downloadPivotViewTokenUsingGET(pivotViewId)

This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.PivotViewManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

PivotViewManagementApi apiInstance = new PivotViewManagementApi();
String pivotViewId = "pivotViewId_example"; // String | The unique identifier of the pivot view
try {
    BaseResponseOfTokenDto result = apiInstance.downloadPivotViewTokenUsingGET(pivotViewId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling PivotViewManagementApi#downloadPivotViewTokenUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewId** | **String**| The unique identifier of the pivot view |

### Return type

[**BaseResponseOfTokenDto**](BaseResponseOfTokenDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="downloadPivotViewUsingGET"></a>
# **downloadPivotViewUsingGET**
> byte[] downloadPivotViewUsingGET(pivotViewId)

This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.PivotViewManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

PivotViewManagementApi apiInstance = new PivotViewManagementApi();
String pivotViewId = "pivotViewId_example"; // String | The unique identifier of the pivot view
try {
    byte[] result = apiInstance.downloadPivotViewUsingGET(pivotViewId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling PivotViewManagementApi#downloadPivotViewUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewId** | **String**| The unique identifier of the pivot view |

### Return type

**byte[]**

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

<a name="getPivotViewUsingGET"></a>
# **getPivotViewUsingGET**
> BaseResponseOfPivotViewDto getPivotViewUsingGET(pivotViewId)

Retrieve a single pivot view

Returns a view with the provided ID, or a 404 if no view matches the ID.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.PivotViewManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

PivotViewManagementApi apiInstance = new PivotViewManagementApi();
String pivotViewId = "pivotViewId_example"; // String | The unique identifier of the pivot view
try {
    BaseResponseOfPivotViewDto result = apiInstance.getPivotViewUsingGET(pivotViewId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling PivotViewManagementApi#getPivotViewUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewId** | **String**| The unique identifier of the pivot view |

### Return type

[**BaseResponseOfPivotViewDto**](BaseResponseOfPivotViewDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="listPivotViewsUsingGET"></a>
# **listPivotViewsUsingGET**
> PagedResponseOfPivotViewDto listPivotViewsUsingGET(queryId, limit, cursor, offset)

Retrieve a list of pivot views

Returns a paged list of views in the workspace of the request. If queryId is provided, the results are limited to only views associated with the query ID.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.PivotViewManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

PivotViewManagementApi apiInstance = new PivotViewManagementApi();
String queryId = "queryId_example"; // String | The unique query identifier to filter the views
Integer limit = 56; // Integer | The number of views to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfPivotViewDto result = apiInstance.listPivotViewsUsingGET(queryId, limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling PivotViewManagementApi#listPivotViewsUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **String**| The unique query identifier to filter the views |
 **limit** | **Integer**| The number of views to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfPivotViewDto**](PagedResponseOfPivotViewDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updatePivotViewUsingPUT"></a>
# **updatePivotViewUsingPUT**
> BaseResponseOfPivotViewDto updatePivotViewUsingPUT(pivotViewId, pivotViewDto)

Update a single pivot view

Updates the view that matches the provided ID with the details provided in the body. The associated query can&#39;t be updated, so providing the query ID has no effect.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.PivotViewManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

PivotViewManagementApi apiInstance = new PivotViewManagementApi();
String pivotViewId = "pivotViewId_example"; // String | The unique identifier of the pivot view
PivotViewDto pivotViewDto = new PivotViewDto(); // PivotViewDto | The representation of the pivot view to create
try {
    BaseResponseOfPivotViewDto result = apiInstance.updatePivotViewUsingPUT(pivotViewId, pivotViewDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling PivotViewManagementApi#updatePivotViewUsingPUT");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewId** | **String**| The unique identifier of the pivot view |
 **pivotViewDto** | [**PivotViewDto**](PivotViewDto.md)| The representation of the pivot view to create | [optional]

### Return type

[**BaseResponseOfPivotViewDto**](BaseResponseOfPivotViewDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

