# SharedTableManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createSharedTableUsingPOST**](SharedTableManagementApi.md#createSharedTableUsingPOST) | **POST** /api/v1/sharedtable | Create a new shared table
[**deleteSharedTableUsingDELETE**](SharedTableManagementApi.md#deleteSharedTableUsingDELETE) | **DELETE** /api/v1/sharedtable/{sharedTableId} | Delete a single shared table
[**getSharedTableUsingGET**](SharedTableManagementApi.md#getSharedTableUsingGET) | **GET** /api/v1/sharedtable/{sharedTableId} | Retrieve a single shared table
[**listSharedTablesUsingGET**](SharedTableManagementApi.md#listSharedTablesUsingGET) | **GET** /api/v1/sharedtable | Retrieve a list of shared tables


<a name="createSharedTableUsingPOST"></a>
# **createSharedTableUsingPOST**
> BaseResponseOfSharedTableDto createSharedTableUsingPOST(sharedTableDto)

Create a new shared table

Creates a shared table instance between the workspace of the request and the workspace provided in the body.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.SharedTableManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

SharedTableManagementApi apiInstance = new SharedTableManagementApi();
SharedTableDto sharedTableDto = new SharedTableDto(); // SharedTableDto | The representation of the shared table to create
try {
    BaseResponseOfSharedTableDto result = apiInstance.createSharedTableUsingPOST(sharedTableDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SharedTableManagementApi#createSharedTableUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sharedTableDto** | [**SharedTableDto**](SharedTableDto.md)| The representation of the shared table to create | [optional]

### Return type

[**BaseResponseOfSharedTableDto**](BaseResponseOfSharedTableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="deleteSharedTableUsingDELETE"></a>
# **deleteSharedTableUsingDELETE**
> BaseResponseOfstring deleteSharedTableUsingDELETE(sharedTableId)

Delete a single shared table

Deletes the linkages between the source and destination of a shared table that matches the provided ID; the actual table itself is left intact. If no such shared table exists, this is a no-op.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.SharedTableManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

SharedTableManagementApi apiInstance = new SharedTableManagementApi();
String sharedTableId = "sharedTableId_example"; // String | The unique identifier of the shared table
try {
    BaseResponseOfstring result = apiInstance.deleteSharedTableUsingDELETE(sharedTableId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SharedTableManagementApi#deleteSharedTableUsingDELETE");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sharedTableId** | **String**| The unique identifier of the shared table |

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getSharedTableUsingGET"></a>
# **getSharedTableUsingGET**
> BaseResponseOfSharedTableDto getSharedTableUsingGET(sharedTableId, sharedWithMe)

Retrieve a single shared table

Returns a shared table that matches the provided ID, or a 404 if no matching shared table is found.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.SharedTableManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

SharedTableManagementApi apiInstance = new SharedTableManagementApi();
String sharedTableId = "sharedTableId_example"; // String | The unique identifier of the shared table
Boolean sharedWithMe = true; // Boolean | If true, returns a shared table with the provided ID that has been shared _to_—rather than from—the workspace of the request.
try {
    BaseResponseOfSharedTableDto result = apiInstance.getSharedTableUsingGET(sharedTableId, sharedWithMe);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SharedTableManagementApi#getSharedTableUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sharedTableId** | **String**| The unique identifier of the shared table |
 **sharedWithMe** | **Boolean**| If true, returns a shared table with the provided ID that has been shared _to_—rather than from—the workspace of the request. | [optional]

### Return type

[**BaseResponseOfSharedTableDto**](BaseResponseOfSharedTableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="listSharedTablesUsingGET"></a>
# **listSharedTablesUsingGET**
> PagedResponseOfSharedTableDto listSharedTablesUsingGET(tableId, sharedWithMe, limit, cursor, offset)

Retrieve a list of shared tables

Returns a list of shared tables associated with the workspace of the request.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.SharedTableManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

SharedTableManagementApi apiInstance = new SharedTableManagementApi();
String tableId = "tableId_example"; // String | The unique table identifier associated with the shared table
Boolean sharedWithMe = true; // Boolean | If true, returns a list of tables that have been shared _to_ it rather than from it. The entities contain both the shared table entity _and_ the table being shared. If true, `tableId` is ignored.
Integer limit = 56; // Integer | The number of shared files to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfSharedTableDto result = apiInstance.listSharedTablesUsingGET(tableId, sharedWithMe, limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SharedTableManagementApi#listSharedTablesUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tableId** | **String**| The unique table identifier associated with the shared table | [optional]
 **sharedWithMe** | **Boolean**| If true, returns a list of tables that have been shared _to_ it rather than from it. The entities contain both the shared table entity _and_ the table being shared. If true, &#x60;tableId&#x60; is ignored. | [optional]
 **limit** | **Integer**| The number of shared files to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfSharedTableDto**](PagedResponseOfSharedTableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

