/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;

import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.PivotViewDto;
import io.swagger.client.model.BaseResponseOfPivotViewDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.BaseResponseOfTokenDto;
import io.swagger.client.model.PagedResponseOfPivotViewDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PivotViewManagementApi {
    private ApiClient apiClient;

    public PivotViewManagementApi() {
        this(Configuration.getDefaultApiClient());
    }

    public PivotViewManagementApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for createPivotViewUsingPOST */
    private com.squareup.okhttp.Call createPivotViewUsingPOSTCall(PivotViewDto pivotViewDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = pivotViewDto;
        

        // create path and map variables
        String localVarPath = "/api/v1/pivotview".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Create a new pivot view
     * Creates a view from the provided information. Currently, persists the provided &#x60;additionalMetadata&#x60; field, which can store an arbitrary JSON definition of a pivot table view. This pivot table must be associated with a query, and can optionally be associated with a query result. When a query is deleted, its associated views are also deleted.
     * @param pivotViewDto The representation of the view to create (optional)
     * @return BaseResponseOfPivotViewDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfPivotViewDto createPivotViewUsingPOST(PivotViewDto pivotViewDto) throws ApiException {
        ApiResponse<BaseResponseOfPivotViewDto> resp = createPivotViewUsingPOSTWithHttpInfo(pivotViewDto);
        return resp.getData();
    }

    /**
     * Create a new pivot view
     * Creates a view from the provided information. Currently, persists the provided &#x60;additionalMetadata&#x60; field, which can store an arbitrary JSON definition of a pivot table view. This pivot table must be associated with a query, and can optionally be associated with a query result. When a query is deleted, its associated views are also deleted.
     * @param pivotViewDto The representation of the view to create (optional)
     * @return ApiResponse&lt;BaseResponseOfPivotViewDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfPivotViewDto> createPivotViewUsingPOSTWithHttpInfo(PivotViewDto pivotViewDto) throws ApiException {
        com.squareup.okhttp.Call call = createPivotViewUsingPOSTCall(pivotViewDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfPivotViewDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new pivot view (asynchronously)
     * Creates a view from the provided information. Currently, persists the provided &#x60;additionalMetadata&#x60; field, which can store an arbitrary JSON definition of a pivot table view. This pivot table must be associated with a query, and can optionally be associated with a query result. When a query is deleted, its associated views are also deleted.
     * @param pivotViewDto The representation of the view to create (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createPivotViewUsingPOSTAsync(PivotViewDto pivotViewDto, final ApiCallback<BaseResponseOfPivotViewDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createPivotViewUsingPOSTCall(pivotViewDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfPivotViewDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for deletePivotViewUsingDELETE */
    private com.squareup.okhttp.Call deletePivotViewUsingDELETECall(String pivotViewId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'pivotViewId' is set
        if (pivotViewId == null) {
            throw new ApiException("Missing the required parameter 'pivotViewId' when calling deletePivotViewUsingDELETE(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/pivotview/{pivotViewId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "pivotViewId" + "\\}", apiClient.escapeString(pivotViewId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Delete a single pivot view
     * Deletes a view that matches the provided ID.  This is an administrative method and should be assumed a hard-delete, given no capability to restore a deleted view is available.  A no-op if no such view exists.
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring deletePivotViewUsingDELETE(String pivotViewId) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = deletePivotViewUsingDELETEWithHttpInfo(pivotViewId);
        return resp.getData();
    }

    /**
     * Delete a single pivot view
     * Deletes a view that matches the provided ID.  This is an administrative method and should be assumed a hard-delete, given no capability to restore a deleted view is available.  A no-op if no such view exists.
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> deletePivotViewUsingDELETEWithHttpInfo(String pivotViewId) throws ApiException {
        com.squareup.okhttp.Call call = deletePivotViewUsingDELETECall(pivotViewId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a single pivot view (asynchronously)
     * Deletes a view that matches the provided ID.  This is an administrative method and should be assumed a hard-delete, given no capability to restore a deleted view is available.  A no-op if no such view exists.
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deletePivotViewUsingDELETEAsync(String pivotViewId, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deletePivotViewUsingDELETECall(pivotViewId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for downloadPivotViewTokenUsingGET */
    private com.squareup.okhttp.Call downloadPivotViewTokenUsingGETCall(String pivotViewId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'pivotViewId' is set
        if (pivotViewId == null) {
            throw new ApiException("Missing the required parameter 'pivotViewId' when calling downloadPivotViewTokenUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/pivotview/{pivotViewId}/token".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "pivotViewId" + "\\}", apiClient.escapeString(pivotViewId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
     * 
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @return BaseResponseOfTokenDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfTokenDto downloadPivotViewTokenUsingGET(String pivotViewId) throws ApiException {
        ApiResponse<BaseResponseOfTokenDto> resp = downloadPivotViewTokenUsingGETWithHttpInfo(pivotViewId);
        return resp.getData();
    }

    /**
     * This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
     * 
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @return ApiResponse&lt;BaseResponseOfTokenDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfTokenDto> downloadPivotViewTokenUsingGETWithHttpInfo(String pivotViewId) throws ApiException {
        com.squareup.okhttp.Call call = downloadPivotViewTokenUsingGETCall(pivotViewId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfTokenDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020. (asynchronously)
     * 
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call downloadPivotViewTokenUsingGETAsync(String pivotViewId, final ApiCallback<BaseResponseOfTokenDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = downloadPivotViewTokenUsingGETCall(pivotViewId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfTokenDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for downloadPivotViewUsingGET */
    private com.squareup.okhttp.Call downloadPivotViewUsingGETCall(String pivotViewId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'pivotViewId' is set
        if (pivotViewId == null) {
            throw new ApiException("Missing the required parameter 'pivotViewId' when calling downloadPivotViewUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/pivotview/{pivotViewId}/download".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "pivotViewId" + "\\}", apiClient.escapeString(pivotViewId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*_/_*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
     * 
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @return byte[]
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public byte[] downloadPivotViewUsingGET(String pivotViewId) throws ApiException {
        ApiResponse<byte[]> resp = downloadPivotViewUsingGETWithHttpInfo(pivotViewId);
        return resp.getData();
    }

    /**
     * This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
     * 
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @return ApiResponse&lt;byte[]&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<byte[]> downloadPivotViewUsingGETWithHttpInfo(String pivotViewId) throws ApiException {
        com.squareup.okhttp.Call call = downloadPivotViewUsingGETCall(pivotViewId, null, null);
        Type localVarReturnType = new TypeToken<byte[]>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020. (asynchronously)
     * 
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call downloadPivotViewUsingGETAsync(String pivotViewId, final ApiCallback<byte[]> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = downloadPivotViewUsingGETCall(pivotViewId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<byte[]>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getPivotViewUsingGET */
    private com.squareup.okhttp.Call getPivotViewUsingGETCall(String pivotViewId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'pivotViewId' is set
        if (pivotViewId == null) {
            throw new ApiException("Missing the required parameter 'pivotViewId' when calling getPivotViewUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/pivotview/{pivotViewId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "pivotViewId" + "\\}", apiClient.escapeString(pivotViewId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a single pivot view
     * Returns a view with the provided ID, or a 404 if no view matches the ID.
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @return BaseResponseOfPivotViewDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfPivotViewDto getPivotViewUsingGET(String pivotViewId) throws ApiException {
        ApiResponse<BaseResponseOfPivotViewDto> resp = getPivotViewUsingGETWithHttpInfo(pivotViewId);
        return resp.getData();
    }

    /**
     * Retrieve a single pivot view
     * Returns a view with the provided ID, or a 404 if no view matches the ID.
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @return ApiResponse&lt;BaseResponseOfPivotViewDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfPivotViewDto> getPivotViewUsingGETWithHttpInfo(String pivotViewId) throws ApiException {
        com.squareup.okhttp.Call call = getPivotViewUsingGETCall(pivotViewId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfPivotViewDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a single pivot view (asynchronously)
     * Returns a view with the provided ID, or a 404 if no view matches the ID.
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getPivotViewUsingGETAsync(String pivotViewId, final ApiCallback<BaseResponseOfPivotViewDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getPivotViewUsingGETCall(pivotViewId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfPivotViewDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for listPivotViewsUsingGET */
    private com.squareup.okhttp.Call listPivotViewsUsingGETCall(String queryId, Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'queryId' is set
        if (queryId == null) {
            throw new ApiException("Missing the required parameter 'queryId' when calling listPivotViewsUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/pivotview".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (queryId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "queryId", queryId));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a list of pivot views
     * Returns a paged list of views in the workspace of the request. If queryId is provided, the results are limited to only views associated with the query ID.
     * @param queryId The unique query identifier to filter the views (required)
     * @param limit The number of views to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfPivotViewDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfPivotViewDto listPivotViewsUsingGET(String queryId, Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfPivotViewDto> resp = listPivotViewsUsingGETWithHttpInfo(queryId, limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve a list of pivot views
     * Returns a paged list of views in the workspace of the request. If queryId is provided, the results are limited to only views associated with the query ID.
     * @param queryId The unique query identifier to filter the views (required)
     * @param limit The number of views to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfPivotViewDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfPivotViewDto> listPivotViewsUsingGETWithHttpInfo(String queryId, Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = listPivotViewsUsingGETCall(queryId, limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfPivotViewDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a list of pivot views (asynchronously)
     * Returns a paged list of views in the workspace of the request. If queryId is provided, the results are limited to only views associated with the query ID.
     * @param queryId The unique query identifier to filter the views (required)
     * @param limit The number of views to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call listPivotViewsUsingGETAsync(String queryId, Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfPivotViewDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = listPivotViewsUsingGETCall(queryId, limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfPivotViewDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for updatePivotViewUsingPUT */
    private com.squareup.okhttp.Call updatePivotViewUsingPUTCall(String pivotViewId, PivotViewDto pivotViewDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = pivotViewDto;
        
        // verify the required parameter 'pivotViewId' is set
        if (pivotViewId == null) {
            throw new ApiException("Missing the required parameter 'pivotViewId' when calling updatePivotViewUsingPUT(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/pivotview/{pivotViewId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "pivotViewId" + "\\}", apiClient.escapeString(pivotViewId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Update a single pivot view
     * Updates the view that matches the provided ID with the details provided in the body. The associated query can&#39;t be updated, so providing the query ID has no effect.
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @param pivotViewDto The representation of the pivot view to create (optional)
     * @return BaseResponseOfPivotViewDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfPivotViewDto updatePivotViewUsingPUT(String pivotViewId, PivotViewDto pivotViewDto) throws ApiException {
        ApiResponse<BaseResponseOfPivotViewDto> resp = updatePivotViewUsingPUTWithHttpInfo(pivotViewId, pivotViewDto);
        return resp.getData();
    }

    /**
     * Update a single pivot view
     * Updates the view that matches the provided ID with the details provided in the body. The associated query can&#39;t be updated, so providing the query ID has no effect.
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @param pivotViewDto The representation of the pivot view to create (optional)
     * @return ApiResponse&lt;BaseResponseOfPivotViewDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfPivotViewDto> updatePivotViewUsingPUTWithHttpInfo(String pivotViewId, PivotViewDto pivotViewDto) throws ApiException {
        com.squareup.okhttp.Call call = updatePivotViewUsingPUTCall(pivotViewId, pivotViewDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfPivotViewDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Update a single pivot view (asynchronously)
     * Updates the view that matches the provided ID with the details provided in the body. The associated query can&#39;t be updated, so providing the query ID has no effect.
     * @param pivotViewId The unique identifier of the pivot view (required)
     * @param pivotViewDto The representation of the pivot view to create (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updatePivotViewUsingPUTAsync(String pivotViewId, PivotViewDto pivotViewDto, final ApiCallback<BaseResponseOfPivotViewDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updatePivotViewUsingPUTCall(pivotViewId, pivotViewDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfPivotViewDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
