/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;

import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.BaseResponseOfQueryResultDto;
import io.swagger.client.model.QueryDto;
import io.swagger.client.model.BaseResponseOfQueryDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.ExportQueryResultDto;
import io.swagger.client.model.PagedResponseOfTableDto;
import io.swagger.client.model.BaseResponseOfQueryColumnDataDto;
import io.swagger.client.model.QueryTextDto;
import io.swagger.client.model.PagedResponseOfQueryDto;
import io.swagger.client.model.PagedResponseOfQueryResultDto;
import io.swagger.client.model.QueryResultDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class QueryManagementApi {
    private ApiClient apiClient;

    public QueryManagementApi() {
        this(Configuration.getDefaultApiClient());
    }

    public QueryManagementApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for cancelQueryUsingDELETE */
    private com.squareup.okhttp.Call cancelQueryUsingDELETECall(String queryResultId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'queryResultId' is set
        if (queryResultId == null) {
            throw new ApiException("Missing the required parameter 'queryResultId' when calling cancelQueryUsingDELETE(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/queryresult/{queryResultId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "queryResultId" + "\\}", apiClient.escapeString(queryResultId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*_/_*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Cancel a running query
     * Cancels a running query based on the provided result ID, and returns a cancelled result unless the query&#39;s already in a COMPLETED state.
     * @param queryResultId The unique identifier of the query result (required)
     * @return BaseResponseOfQueryResultDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfQueryResultDto cancelQueryUsingDELETE(String queryResultId) throws ApiException {
        ApiResponse<BaseResponseOfQueryResultDto> resp = cancelQueryUsingDELETEWithHttpInfo(queryResultId);
        return resp.getData();
    }

    /**
     * Cancel a running query
     * Cancels a running query based on the provided result ID, and returns a cancelled result unless the query&#39;s already in a COMPLETED state.
     * @param queryResultId The unique identifier of the query result (required)
     * @return ApiResponse&lt;BaseResponseOfQueryResultDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfQueryResultDto> cancelQueryUsingDELETEWithHttpInfo(String queryResultId) throws ApiException {
        com.squareup.okhttp.Call call = cancelQueryUsingDELETECall(queryResultId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryResultDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Cancel a running query (asynchronously)
     * Cancels a running query based on the provided result ID, and returns a cancelled result unless the query&#39;s already in a COMPLETED state.
     * @param queryResultId The unique identifier of the query result (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call cancelQueryUsingDELETEAsync(String queryResultId, final ApiCallback<BaseResponseOfQueryResultDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = cancelQueryUsingDELETECall(queryResultId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryResultDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for createQueryUsingPOST */
    private com.squareup.okhttp.Call createQueryUsingPOSTCall(QueryDto queryDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = queryDto;
        

        // create path and map variables
        String localVarPath = "/api/v1/query".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Create a new query
     * Creates a query object and validates full permissions to ensure the requestor has access to all data sources being queried. This endpoint _doesn&#39;t_ execute the query; to execute, call the POST /queryresult method.
     * @param queryDto The representation of the query to create (optional)
     * @return BaseResponseOfQueryDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfQueryDto createQueryUsingPOST(QueryDto queryDto) throws ApiException {
        ApiResponse<BaseResponseOfQueryDto> resp = createQueryUsingPOSTWithHttpInfo(queryDto);
        return resp.getData();
    }

    /**
     * Create a new query
     * Creates a query object and validates full permissions to ensure the requestor has access to all data sources being queried. This endpoint _doesn&#39;t_ execute the query; to execute, call the POST /queryresult method.
     * @param queryDto The representation of the query to create (optional)
     * @return ApiResponse&lt;BaseResponseOfQueryDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfQueryDto> createQueryUsingPOSTWithHttpInfo(QueryDto queryDto) throws ApiException {
        com.squareup.okhttp.Call call = createQueryUsingPOSTCall(queryDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new query (asynchronously)
     * Creates a query object and validates full permissions to ensure the requestor has access to all data sources being queried. This endpoint _doesn&#39;t_ execute the query; to execute, call the POST /queryresult method.
     * @param queryDto The representation of the query to create (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createQueryUsingPOSTAsync(QueryDto queryDto, final ApiCallback<BaseResponseOfQueryDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createQueryUsingPOSTCall(queryDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for deleteQueryUsingDELETE */
    private com.squareup.okhttp.Call deleteQueryUsingDELETECall(String queryId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'queryId' is set
        if (queryId == null) {
            throw new ApiException("Missing the required parameter 'queryId' when calling deleteQueryUsingDELETE(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/query/{queryId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "queryId" + "\\}", apiClient.escapeString(queryId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*_/_*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Delete a single query
     * Deletes the query that matches the provided ID. If no such query is found, this is a no-op.
     * @param queryId The unique identifier of the query (required)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring deleteQueryUsingDELETE(String queryId) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = deleteQueryUsingDELETEWithHttpInfo(queryId);
        return resp.getData();
    }

    /**
     * Delete a single query
     * Deletes the query that matches the provided ID. If no such query is found, this is a no-op.
     * @param queryId The unique identifier of the query (required)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> deleteQueryUsingDELETEWithHttpInfo(String queryId) throws ApiException {
        com.squareup.okhttp.Call call = deleteQueryUsingDELETECall(queryId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a single query (asynchronously)
     * Deletes the query that matches the provided ID. If no such query is found, this is a no-op.
     * @param queryId The unique identifier of the query (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteQueryUsingDELETEAsync(String queryId, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteQueryUsingDELETECall(queryId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for downloadQueryResultUsingGET */
    private com.squareup.okhttp.Call downloadQueryResultUsingGETCall(String queryResultId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'queryResultId' is set
        if (queryResultId == null) {
            throw new ApiException("Missing the required parameter 'queryResultId' when calling downloadQueryResultUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/queryresult/{queryResultId}/download".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "queryResultId" + "\\}", apiClient.escapeString(queryResultId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*_/_*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Download a query result
     * Uses the Token Management API to create a token with the query result ID, which it then uses to download a CSV file of the query results.
     * @param queryResultId The unique identifier of the query result (required)
     * @return byte[]
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public byte[] downloadQueryResultUsingGET(String queryResultId) throws ApiException {
        ApiResponse<byte[]> resp = downloadQueryResultUsingGETWithHttpInfo(queryResultId);
        return resp.getData();
    }

    /**
     * Download a query result
     * Uses the Token Management API to create a token with the query result ID, which it then uses to download a CSV file of the query results.
     * @param queryResultId The unique identifier of the query result (required)
     * @return ApiResponse&lt;byte[]&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<byte[]> downloadQueryResultUsingGETWithHttpInfo(String queryResultId) throws ApiException {
        com.squareup.okhttp.Call call = downloadQueryResultUsingGETCall(queryResultId, null, null);
        Type localVarReturnType = new TypeToken<byte[]>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Download a query result (asynchronously)
     * Uses the Token Management API to create a token with the query result ID, which it then uses to download a CSV file of the query results.
     * @param queryResultId The unique identifier of the query result (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call downloadQueryResultUsingGETAsync(String queryResultId, final ApiCallback<byte[]> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = downloadQueryResultUsingGETCall(queryResultId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<byte[]>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for exportQueryResultToSpreadsheetsUsingPOST */
    private com.squareup.okhttp.Call exportQueryResultToSpreadsheetsUsingPOSTCall(String queryResultId, ExportQueryResultDto dto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = dto;
        
        // verify the required parameter 'queryResultId' is set
        if (queryResultId == null) {
            throw new ApiException("Missing the required parameter 'queryResultId' when calling exportQueryResultToSpreadsheetsUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/queryresult/{queryResultId}/export".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "queryResultId" + "\\}", apiClient.escapeString(queryResultId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Export query result to spreadsheets
     * Exports a query result with the provided ID to Spreadsheets. To determine where to export the results, the request body should include a URL copied and pasted from the Spreadsheets UI. Returns a 404 if no matching query result is found.
     * @param queryResultId The unique identifier of the query result (required)
     * @param dto The representation of the export query result (optional)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring exportQueryResultToSpreadsheetsUsingPOST(String queryResultId, ExportQueryResultDto dto) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = exportQueryResultToSpreadsheetsUsingPOSTWithHttpInfo(queryResultId, dto);
        return resp.getData();
    }

    /**
     * Export query result to spreadsheets
     * Exports a query result with the provided ID to Spreadsheets. To determine where to export the results, the request body should include a URL copied and pasted from the Spreadsheets UI. Returns a 404 if no matching query result is found.
     * @param queryResultId The unique identifier of the query result (required)
     * @param dto The representation of the export query result (optional)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> exportQueryResultToSpreadsheetsUsingPOSTWithHttpInfo(String queryResultId, ExportQueryResultDto dto) throws ApiException {
        com.squareup.okhttp.Call call = exportQueryResultToSpreadsheetsUsingPOSTCall(queryResultId, dto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Export query result to spreadsheets (asynchronously)
     * Exports a query result with the provided ID to Spreadsheets. To determine where to export the results, the request body should include a URL copied and pasted from the Spreadsheets UI. Returns a 404 if no matching query result is found.
     * @param queryResultId The unique identifier of the query result (required)
     * @param dto The representation of the export query result (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call exportQueryResultToSpreadsheetsUsingPOSTAsync(String queryResultId, ExportQueryResultDto dto, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = exportQueryResultToSpreadsheetsUsingPOSTCall(queryResultId, dto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getDependenciesUsingGET */
    private com.squareup.okhttp.Call getDependenciesUsingGETCall(String queryId, Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'queryId' is set
        if (queryId == null) {
            throw new ApiException("Missing the required parameter 'queryId' when calling getDependenciesUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/query/{queryId}/dependencies".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "queryId" + "\\}", apiClient.escapeString(queryId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve dependencies
     * Returns an unordered collection of all tables the matching query uses as datasources, including any shared tables outside of this OAuth token&#39;s workspace. The endpoint verifies the user has read permissions on the query, but _not_ on the tables returned.
     * @param queryId The unique identifier of the query (required)
     * @param limit The number of dependencies to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfTableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfTableDto getDependenciesUsingGET(String queryId, Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfTableDto> resp = getDependenciesUsingGETWithHttpInfo(queryId, limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve dependencies
     * Returns an unordered collection of all tables the matching query uses as datasources, including any shared tables outside of this OAuth token&#39;s workspace. The endpoint verifies the user has read permissions on the query, but _not_ on the tables returned.
     * @param queryId The unique identifier of the query (required)
     * @param limit The number of dependencies to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfTableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfTableDto> getDependenciesUsingGETWithHttpInfo(String queryId, Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = getDependenciesUsingGETCall(queryId, limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfTableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve dependencies (asynchronously)
     * Returns an unordered collection of all tables the matching query uses as datasources, including any shared tables outside of this OAuth token&#39;s workspace. The endpoint verifies the user has read permissions on the query, but _not_ on the tables returned.
     * @param queryId The unique identifier of the query (required)
     * @param limit The number of dependencies to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getDependenciesUsingGETAsync(String queryId, Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfTableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getDependenciesUsingGETCall(queryId, limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfTableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getQueryColumnDataUsingPOST */
    private com.squareup.okhttp.Call getQueryColumnDataUsingPOSTCall(QueryTextDto queryTextDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = queryTextDto;
        
        // verify the required parameter 'queryTextDto' is set
        if (queryTextDto == null) {
            throw new ApiException("Missing the required parameter 'queryTextDto' when calling getQueryColumnDataUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/query/data".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve query column data
     * Returns a QueryColumnDataDto representing the column data for the given query text. If the query isn&#39;t valid, returns a 400.
     * @param queryTextDto The query text to parse, up to 30000 characters; must not be null or empty (required)
     * @return BaseResponseOfQueryColumnDataDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfQueryColumnDataDto getQueryColumnDataUsingPOST(QueryTextDto queryTextDto) throws ApiException {
        ApiResponse<BaseResponseOfQueryColumnDataDto> resp = getQueryColumnDataUsingPOSTWithHttpInfo(queryTextDto);
        return resp.getData();
    }

    /**
     * Retrieve query column data
     * Returns a QueryColumnDataDto representing the column data for the given query text. If the query isn&#39;t valid, returns a 400.
     * @param queryTextDto The query text to parse, up to 30000 characters; must not be null or empty (required)
     * @return ApiResponse&lt;BaseResponseOfQueryColumnDataDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfQueryColumnDataDto> getQueryColumnDataUsingPOSTWithHttpInfo(QueryTextDto queryTextDto) throws ApiException {
        com.squareup.okhttp.Call call = getQueryColumnDataUsingPOSTCall(queryTextDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryColumnDataDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve query column data (asynchronously)
     * Returns a QueryColumnDataDto representing the column data for the given query text. If the query isn&#39;t valid, returns a 400.
     * @param queryTextDto The query text to parse, up to 30000 characters; must not be null or empty (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getQueryColumnDataUsingPOSTAsync(QueryTextDto queryTextDto, final ApiCallback<BaseResponseOfQueryColumnDataDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getQueryColumnDataUsingPOSTCall(queryTextDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryColumnDataDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getQueryResultUsingGET */
    private com.squareup.okhttp.Call getQueryResultUsingGETCall(String queryResultId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'queryResultId' is set
        if (queryResultId == null) {
            throw new ApiException("Missing the required parameter 'queryResultId' when calling getQueryResultUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/queryresult/{queryResultId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "queryResultId" + "\\}", apiClient.escapeString(queryResultId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a single query result
     * Returns a single query result that matches the provided ID, or a 404 if no such query result is found.
     * @param queryResultId The unique identifier of the query result (required)
     * @return BaseResponseOfQueryResultDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfQueryResultDto getQueryResultUsingGET(String queryResultId) throws ApiException {
        ApiResponse<BaseResponseOfQueryResultDto> resp = getQueryResultUsingGETWithHttpInfo(queryResultId);
        return resp.getData();
    }

    /**
     * Retrieve a single query result
     * Returns a single query result that matches the provided ID, or a 404 if no such query result is found.
     * @param queryResultId The unique identifier of the query result (required)
     * @return ApiResponse&lt;BaseResponseOfQueryResultDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfQueryResultDto> getQueryResultUsingGETWithHttpInfo(String queryResultId) throws ApiException {
        com.squareup.okhttp.Call call = getQueryResultUsingGETCall(queryResultId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryResultDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a single query result (asynchronously)
     * Returns a single query result that matches the provided ID, or a 404 if no such query result is found.
     * @param queryResultId The unique identifier of the query result (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getQueryResultUsingGETAsync(String queryResultId, final ApiCallback<BaseResponseOfQueryResultDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getQueryResultUsingGETCall(queryResultId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryResultDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getQueryUsingGET */
    private com.squareup.okhttp.Call getQueryUsingGETCall(String queryId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'queryId' is set
        if (queryId == null) {
            throw new ApiException("Missing the required parameter 'queryId' when calling getQueryUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/query/{queryId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "queryId" + "\\}", apiClient.escapeString(queryId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a single query
     * Returns a query that matches the provided ID, or a 404 if no matching query is found.
     * @param queryId The unique identifier of the query (required)
     * @return BaseResponseOfQueryDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfQueryDto getQueryUsingGET(String queryId) throws ApiException {
        ApiResponse<BaseResponseOfQueryDto> resp = getQueryUsingGETWithHttpInfo(queryId);
        return resp.getData();
    }

    /**
     * Retrieve a single query
     * Returns a query that matches the provided ID, or a 404 if no matching query is found.
     * @param queryId The unique identifier of the query (required)
     * @return ApiResponse&lt;BaseResponseOfQueryDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfQueryDto> getQueryUsingGETWithHttpInfo(String queryId) throws ApiException {
        com.squareup.okhttp.Call call = getQueryUsingGETCall(queryId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a single query (asynchronously)
     * Returns a query that matches the provided ID, or a 404 if no matching query is found.
     * @param queryId The unique identifier of the query (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getQueryUsingGETAsync(String queryId, final ApiCallback<BaseResponseOfQueryDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getQueryUsingGETCall(queryId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getTablesDependentOnQueryUsingGET */
    private com.squareup.okhttp.Call getTablesDependentOnQueryUsingGETCall(String queryId, Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'queryId' is set
        if (queryId == null) {
            throw new ApiException("Missing the required parameter 'queryId' when calling getTablesDependentOnQueryUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/query/{queryId}/dependents".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "queryId" + "\\}", apiClient.escapeString(queryId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*_/_*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a list of dependents
     * Returns a list of all tables that use the query with provided ID as a datasource. 
     * @param queryId The unique identifier of the query (required)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfTableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfTableDto getTablesDependentOnQueryUsingGET(String queryId, Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfTableDto> resp = getTablesDependentOnQueryUsingGETWithHttpInfo(queryId, limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve a list of dependents
     * Returns a list of all tables that use the query with provided ID as a datasource. 
     * @param queryId The unique identifier of the query (required)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfTableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfTableDto> getTablesDependentOnQueryUsingGETWithHttpInfo(String queryId, Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = getTablesDependentOnQueryUsingGETCall(queryId, limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfTableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a list of dependents (asynchronously)
     * Returns a list of all tables that use the query with provided ID as a datasource. 
     * @param queryId The unique identifier of the query (required)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getTablesDependentOnQueryUsingGETAsync(String queryId, Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfTableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getTablesDependentOnQueryUsingGETCall(queryId, limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfTableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for isQueryValidUsingPOST */
    private com.squareup.okhttp.Call isQueryValidUsingPOSTCall(QueryDto queryDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = queryDto;
        

        // create path and map variables
        String localVarPath = "/api/v1/query/validation".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Parses the query to determine if it is valid
     * Returns the provided QueryDto
     * @param queryDto The representation of the created query (optional)
     * @return BaseResponseOfQueryDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfQueryDto isQueryValidUsingPOST(QueryDto queryDto) throws ApiException {
        ApiResponse<BaseResponseOfQueryDto> resp = isQueryValidUsingPOSTWithHttpInfo(queryDto);
        return resp.getData();
    }

    /**
     * Parses the query to determine if it is valid
     * Returns the provided QueryDto
     * @param queryDto The representation of the created query (optional)
     * @return ApiResponse&lt;BaseResponseOfQueryDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfQueryDto> isQueryValidUsingPOSTWithHttpInfo(QueryDto queryDto) throws ApiException {
        com.squareup.okhttp.Call call = isQueryValidUsingPOSTCall(queryDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Parses the query to determine if it is valid (asynchronously)
     * Returns the provided QueryDto
     * @param queryDto The representation of the created query (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call isQueryValidUsingPOSTAsync(QueryDto queryDto, final ApiCallback<BaseResponseOfQueryDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = isQueryValidUsingPOSTCall(queryDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for listQueriesUsingGET */
    private com.squareup.okhttp.Call listQueriesUsingGETCall(Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/query".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve list of queries
     * Returns a list of all non-temporary queries associated with the workspace. By default, these queries are ordered by their names, in ascending order.
     * @param limit The number of queries to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfQueryDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfQueryDto listQueriesUsingGET(Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfQueryDto> resp = listQueriesUsingGETWithHttpInfo(limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve list of queries
     * Returns a list of all non-temporary queries associated with the workspace. By default, these queries are ordered by their names, in ascending order.
     * @param limit The number of queries to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfQueryDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfQueryDto> listQueriesUsingGETWithHttpInfo(Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = listQueriesUsingGETCall(limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfQueryDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve list of queries (asynchronously)
     * Returns a list of all non-temporary queries associated with the workspace. By default, these queries are ordered by their names, in ascending order.
     * @param limit The number of queries to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call listQueriesUsingGETAsync(Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfQueryDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = listQueriesUsingGETCall(limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfQueryDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for listQueryResultsUsingGET */
    private com.squareup.okhttp.Call listQueryResultsUsingGETCall(String queryId, String cursor, Integer limit, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/queryresult".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (queryId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "queryId", queryId));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a list of query results
     * Returns a paged list of query results that match the provided query ID, or an empty list if no matching query is found.
     * @param queryId The unique identifier of the query (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param limit The number of query results to return, from 1 to 1000; by default, 1000 (optional, default to 1000)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional, default to 0)
     * @return PagedResponseOfQueryResultDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfQueryResultDto listQueryResultsUsingGET(String queryId, String cursor, Integer limit, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfQueryResultDto> resp = listQueryResultsUsingGETWithHttpInfo(queryId, cursor, limit, offset);
        return resp.getData();
    }

    /**
     * Retrieve a list of query results
     * Returns a paged list of query results that match the provided query ID, or an empty list if no matching query is found.
     * @param queryId The unique identifier of the query (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param limit The number of query results to return, from 1 to 1000; by default, 1000 (optional, default to 1000)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional, default to 0)
     * @return ApiResponse&lt;PagedResponseOfQueryResultDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfQueryResultDto> listQueryResultsUsingGETWithHttpInfo(String queryId, String cursor, Integer limit, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = listQueryResultsUsingGETCall(queryId, cursor, limit, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfQueryResultDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a list of query results (asynchronously)
     * Returns a paged list of query results that match the provided query ID, or an empty list if no matching query is found.
     * @param queryId The unique identifier of the query (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param limit The number of query results to return, from 1 to 1000; by default, 1000 (optional, default to 1000)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional, default to 0)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call listQueryResultsUsingGETAsync(String queryId, String cursor, Integer limit, Long offset, final ApiCallback<PagedResponseOfQueryResultDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = listQueryResultsUsingGETCall(queryId, cursor, limit, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfQueryResultDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for previewQueryUsingPOST */
    private com.squareup.okhttp.Call previewQueryUsingPOSTCall(String tableId, Integer limit, String fileName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling previewQueryUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/query/preview/{tableId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (fileName != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "fileName", fileName));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Preview a query
     * Creates a limited scope query object, but does _not_ execute it. The query selects all values against the provided table, up to 10 rows. This endpoint may allow unpermissioned users to preview table data; full permissions to datasources are _not_ validated.
     * @param tableId The identifier of the table to query (required)
     * @param limit The number of rows to return (optional)
     * @param fileName The name of the file to create (optional)
     * @return BaseResponseOfQueryDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfQueryDto previewQueryUsingPOST(String tableId, Integer limit, String fileName) throws ApiException {
        ApiResponse<BaseResponseOfQueryDto> resp = previewQueryUsingPOSTWithHttpInfo(tableId, limit, fileName);
        return resp.getData();
    }

    /**
     * Preview a query
     * Creates a limited scope query object, but does _not_ execute it. The query selects all values against the provided table, up to 10 rows. This endpoint may allow unpermissioned users to preview table data; full permissions to datasources are _not_ validated.
     * @param tableId The identifier of the table to query (required)
     * @param limit The number of rows to return (optional)
     * @param fileName The name of the file to create (optional)
     * @return ApiResponse&lt;BaseResponseOfQueryDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfQueryDto> previewQueryUsingPOSTWithHttpInfo(String tableId, Integer limit, String fileName) throws ApiException {
        com.squareup.okhttp.Call call = previewQueryUsingPOSTCall(tableId, limit, fileName, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Preview a query (asynchronously)
     * Creates a limited scope query object, but does _not_ execute it. The query selects all values against the provided table, up to 10 rows. This endpoint may allow unpermissioned users to preview table data; full permissions to datasources are _not_ validated.
     * @param tableId The identifier of the table to query (required)
     * @param limit The number of rows to return (optional)
     * @param fileName The name of the file to create (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call previewQueryUsingPOSTAsync(String tableId, Integer limit, String fileName, final ApiCallback<BaseResponseOfQueryDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = previewQueryUsingPOSTCall(tableId, limit, fileName, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for runQueryUsingPOST */
    private com.squareup.okhttp.Call runQueryUsingPOSTCall(QueryResultDto queryResultDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = queryResultDto;
        

        // create path and map variables
        String localVarPath = "/api/v1/queryresult".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Execute a query
     * Runs a query and immediately returns a query result entity, which has an ID that can be used to poll the status from the GET /queryresult method. A status of COMPLETED or ERROR indicates the query has completed.
     * @param queryResultDto The representation of the created query (optional)
     * @return BaseResponseOfQueryResultDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfQueryResultDto runQueryUsingPOST(QueryResultDto queryResultDto) throws ApiException {
        ApiResponse<BaseResponseOfQueryResultDto> resp = runQueryUsingPOSTWithHttpInfo(queryResultDto);
        return resp.getData();
    }

    /**
     * Execute a query
     * Runs a query and immediately returns a query result entity, which has an ID that can be used to poll the status from the GET /queryresult method. A status of COMPLETED or ERROR indicates the query has completed.
     * @param queryResultDto The representation of the created query (optional)
     * @return ApiResponse&lt;BaseResponseOfQueryResultDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfQueryResultDto> runQueryUsingPOSTWithHttpInfo(QueryResultDto queryResultDto) throws ApiException {
        com.squareup.okhttp.Call call = runQueryUsingPOSTCall(queryResultDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryResultDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Execute a query (asynchronously)
     * Runs a query and immediately returns a query result entity, which has an ID that can be used to poll the status from the GET /queryresult method. A status of COMPLETED or ERROR indicates the query has completed.
     * @param queryResultDto The representation of the created query (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call runQueryUsingPOSTAsync(QueryResultDto queryResultDto, final ApiCallback<BaseResponseOfQueryResultDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = runQueryUsingPOSTCall(queryResultDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryResultDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for updateQueryUsingPUT */
    private com.squareup.okhttp.Call updateQueryUsingPUTCall(String queryId, QueryDto queryDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = queryDto;
        
        // verify the required parameter 'queryId' is set
        if (queryId == null) {
            throw new ApiException("Missing the required parameter 'queryId' when calling updateQueryUsingPUT(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/query/{queryId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "queryId" + "\\}", apiClient.escapeString(queryId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Update a single query
     * Updates the query that matches the provided ID with the details provided in the body.
     * @param queryId The unique identifier of the query (required)
     * @param queryDto The representation of the query to update (optional)
     * @return BaseResponseOfQueryDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfQueryDto updateQueryUsingPUT(String queryId, QueryDto queryDto) throws ApiException {
        ApiResponse<BaseResponseOfQueryDto> resp = updateQueryUsingPUTWithHttpInfo(queryId, queryDto);
        return resp.getData();
    }

    /**
     * Update a single query
     * Updates the query that matches the provided ID with the details provided in the body.
     * @param queryId The unique identifier of the query (required)
     * @param queryDto The representation of the query to update (optional)
     * @return ApiResponse&lt;BaseResponseOfQueryDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfQueryDto> updateQueryUsingPUTWithHttpInfo(String queryId, QueryDto queryDto) throws ApiException {
        com.squareup.okhttp.Call call = updateQueryUsingPUTCall(queryId, queryDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Update a single query (asynchronously)
     * Updates the query that matches the provided ID with the details provided in the body.
     * @param queryId The unique identifier of the query (required)
     * @param queryDto The representation of the query to update (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateQueryUsingPUTAsync(String queryId, QueryDto queryDto, final ApiCallback<BaseResponseOfQueryDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateQueryUsingPUTCall(queryId, queryDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfQueryDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
