/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;

import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.TagDto;
import io.swagger.client.model.BaseResponseOfTagDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.PagedResponseOfTagDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TagManagementApi {
    private ApiClient apiClient;

    public TagManagementApi() {
        this(Configuration.getDefaultApiClient());
    }

    public TagManagementApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for createTagUsingPOST */
    private com.squareup.okhttp.Call createTagUsingPOSTCall(TagDto tagDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = tagDto;
        

        // create path and map variables
        String localVarPath = "/api/v1/tag".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Create a new tag
     * Creates a tag. If another tag already has the same key, returns a 409.
     * @param tagDto The representation of the tag to create (optional)
     * @return BaseResponseOfTagDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfTagDto createTagUsingPOST(TagDto tagDto) throws ApiException {
        ApiResponse<BaseResponseOfTagDto> resp = createTagUsingPOSTWithHttpInfo(tagDto);
        return resp.getData();
    }

    /**
     * Create a new tag
     * Creates a tag. If another tag already has the same key, returns a 409.
     * @param tagDto The representation of the tag to create (optional)
     * @return ApiResponse&lt;BaseResponseOfTagDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfTagDto> createTagUsingPOSTWithHttpInfo(TagDto tagDto) throws ApiException {
        com.squareup.okhttp.Call call = createTagUsingPOSTCall(tagDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfTagDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new tag (asynchronously)
     * Creates a tag. If another tag already has the same key, returns a 409.
     * @param tagDto The representation of the tag to create (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createTagUsingPOSTAsync(TagDto tagDto, final ApiCallback<BaseResponseOfTagDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createTagUsingPOSTCall(tagDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfTagDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for deleteTagUsingDELETE */
    private com.squareup.okhttp.Call deleteTagUsingDELETECall(String tagId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'tagId' is set
        if (tagId == null) {
            throw new ApiException("Missing the required parameter 'tagId' when calling deleteTagUsingDELETE(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/tag/{tagId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tagId" + "\\}", apiClient.escapeString(tagId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Delete a single tag
     * Deletes the tag with the provided ID. If no such tag is found, this is a no-op.
     * @param tagId The unique identifier of the tag (required)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring deleteTagUsingDELETE(String tagId) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = deleteTagUsingDELETEWithHttpInfo(tagId);
        return resp.getData();
    }

    /**
     * Delete a single tag
     * Deletes the tag with the provided ID. If no such tag is found, this is a no-op.
     * @param tagId The unique identifier of the tag (required)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> deleteTagUsingDELETEWithHttpInfo(String tagId) throws ApiException {
        com.squareup.okhttp.Call call = deleteTagUsingDELETECall(tagId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a single tag (asynchronously)
     * Deletes the tag with the provided ID. If no such tag is found, this is a no-op.
     * @param tagId The unique identifier of the tag (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteTagUsingDELETEAsync(String tagId, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteTagUsingDELETECall(tagId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for listTagsUsingGET */
    private com.squareup.okhttp.Call listTagsUsingGETCall(Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/tag".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a list of tags
     * Returns a paged list of all tags associated with the workspace of the request.
     * @param limit The number of tags to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfTagDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfTagDto listTagsUsingGET(Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfTagDto> resp = listTagsUsingGETWithHttpInfo(limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve a list of tags
     * Returns a paged list of all tags associated with the workspace of the request.
     * @param limit The number of tags to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfTagDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfTagDto> listTagsUsingGETWithHttpInfo(Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = listTagsUsingGETCall(limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfTagDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a list of tags (asynchronously)
     * Returns a paged list of all tags associated with the workspace of the request.
     * @param limit The number of tags to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call listTagsUsingGETAsync(Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfTagDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = listTagsUsingGETCall(limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfTagDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for updateTagUsingPUT */
    private com.squareup.okhttp.Call updateTagUsingPUTCall(String tagId, TagDto tagDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = tagDto;
        
        // verify the required parameter 'tagId' is set
        if (tagId == null) {
            throw new ApiException("Missing the required parameter 'tagId' when calling updateTagUsingPUT(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/tag/{tagId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tagId" + "\\}", apiClient.escapeString(tagId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Update a single tag
     * Updates the tag that matches the provided ID with the details provided in the body. Ignores the provided key, as keys are immutable once set.
     * @param tagId The unique identifier of the tag (required)
     * @param tagDto The representation of the tag to update (optional)
     * @return BaseResponseOfTagDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfTagDto updateTagUsingPUT(String tagId, TagDto tagDto) throws ApiException {
        ApiResponse<BaseResponseOfTagDto> resp = updateTagUsingPUTWithHttpInfo(tagId, tagDto);
        return resp.getData();
    }

    /**
     * Update a single tag
     * Updates the tag that matches the provided ID with the details provided in the body. Ignores the provided key, as keys are immutable once set.
     * @param tagId The unique identifier of the tag (required)
     * @param tagDto The representation of the tag to update (optional)
     * @return ApiResponse&lt;BaseResponseOfTagDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfTagDto> updateTagUsingPUTWithHttpInfo(String tagId, TagDto tagDto) throws ApiException {
        com.squareup.okhttp.Call call = updateTagUsingPUTCall(tagId, tagDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfTagDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Update a single tag (asynchronously)
     * Updates the tag that matches the provided ID with the details provided in the body. Ignores the provided key, as keys are immutable once set.
     * @param tagId The unique identifier of the tag (required)
     * @param tagDto The representation of the tag to update (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateTagUsingPUTAsync(String tagId, TagDto tagDto, final ApiCallback<BaseResponseOfTagDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateTagUsingPUTCall(tagId, tagDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfTagDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
