/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * ColumnDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class ColumnDto   {
  @SerializedName("alias")
  private String alias = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("metadata")
  private Map<String, Object> metadata = new HashMap<String, Object>();

  /**
   * This property is for future use, currently always set to nullable
   */
  public enum ModeEnum {
    @SerializedName("nullable")
    NULLABLE("nullable"),
    
    @SerializedName("required")
    REQUIRED("required"),
    
    @SerializedName("repeated")
    REPEATED("repeated");

    private String value;

    ModeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("mode")
  private ModeEnum mode = null;

  @SerializedName("name")
  private String name = null;

  /**
   * The type of column
   */
  public enum TypeEnum {
    @SerializedName("string")
    STRING("string"),
    
    @SerializedName("bytes")
    BYTES("bytes"),
    
    @SerializedName("integer")
    INTEGER("integer"),
    
    @SerializedName("float")
    FLOAT("float"),
    
    @SerializedName("boolean")
    BOOLEAN("boolean"),
    
    @SerializedName("timestamp")
    TIMESTAMP("timestamp"),
    
    @SerializedName("date")
    DATE("date"),
    
    @SerializedName("time")
    TIME("time"),
    
    @SerializedName("datetime")
    DATETIME("datetime"),
    
    @SerializedName("global_parameter")
    GLOBAL_PARAMETER("global_parameter"),
    
    @SerializedName("nested_query_parameter")
    NESTED_QUERY_PARAMETER("nested_query_parameter");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("type")
  private TypeEnum type = null;

  public ColumnDto alias(String alias) {
    this.alias = alias;
    return this;
  }

   /**
   * Optional alias, may be at most 255 characters in length
   * @return alias
  **/
  @ApiModelProperty(example = "null", value = "Optional alias, may be at most 255 characters in length")
  public String getAlias() {
    return alias;
  }

  public void setAlias(String alias) {
    this.alias = alias;
  }

  public ColumnDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * May be at most 255 characters in length
   * @return description
  **/
  @ApiModelProperty(example = "null", value = "May be at most 255 characters in length")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ColumnDto metadata(Map<String, Object> metadata) {
    this.metadata = metadata;
    return this;
  }

  public ColumnDto putMetadataItem(String key, Object metadataItem) {
    this.metadata.put(key, metadataItem);
    return this;
  }

   /**
   * Optional type metadata. Current allowed parameters are: 'formatString' allows users to define their own Java8 datetime format string.'numberFormat' allows parsing of alternative decimal formats such as 1.000,00
   * @return metadata
  **/
  @ApiModelProperty(example = "null", value = "Optional type metadata. Current allowed parameters are: 'formatString' allows users to define their own Java8 datetime format string.'numberFormat' allows parsing of alternative decimal formats such as 1.000,00")
  public Map<String, Object> getMetadata() {
    return metadata;
  }

  public void setMetadata(Map<String, Object> metadata) {
    this.metadata = metadata;
  }

  public ColumnDto mode(ModeEnum mode) {
    this.mode = mode;
    return this;
  }

   /**
   * This property is for future use, currently always set to nullable
   * @return mode
  **/
  @ApiModelProperty(example = "null", value = "This property is for future use, currently always set to nullable")
  public ModeEnum getMode() {
    return mode;
  }

  public void setMode(ModeEnum mode) {
    this.mode = mode;
  }

  public ColumnDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * May be at most 100 characters in length
   * @return name
  **/
  @ApiModelProperty(example = "null", required = true, value = "May be at most 100 characters in length")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ColumnDto type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * The type of column
   * @return type
  **/
  @ApiModelProperty(example = "null", value = "The type of column")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ColumnDto columnDto = (ColumnDto) o;
    return Objects.equals(this.alias, columnDto.alias) &&
        Objects.equals(this.description, columnDto.description) &&
        Objects.equals(this.metadata, columnDto.metadata) &&
        Objects.equals(this.mode, columnDto.mode) &&
        Objects.equals(this.name, columnDto.name) &&
        Objects.equals(this.type, columnDto.type);
  }

  @Override
  public int hashCode() {
    return Objects.hash(alias, description, metadata, mode, name, type);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ColumnDto {\n");
    
    sb.append("    alias: ").append(toIndentedString(alias)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    mode: ").append(toIndentedString(mode)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

