/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Contains column name and derived type from the associated query.
 */
@ApiModel(description = "Contains column name and derived type from the associated query.")
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class ColumnInfoDto   {
  @SerializedName("name")
  private String name = null;

  /**
   * The column's type
   */
  public enum TypeEnum {
    @SerializedName("string")
    STRING("string"),
    
    @SerializedName("bytes")
    BYTES("bytes"),
    
    @SerializedName("integer")
    INTEGER("integer"),
    
    @SerializedName("float")
    FLOAT("float"),
    
    @SerializedName("boolean")
    BOOLEAN("boolean"),
    
    @SerializedName("timestamp")
    TIMESTAMP("timestamp"),
    
    @SerializedName("date")
    DATE("date"),
    
    @SerializedName("time")
    TIME("time"),
    
    @SerializedName("datetime")
    DATETIME("datetime"),
    
    @SerializedName("global_parameter")
    GLOBAL_PARAMETER("global_parameter"),
    
    @SerializedName("nested_query_parameter")
    NESTED_QUERY_PARAMETER("nested_query_parameter");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("type")
  private TypeEnum type = null;

   /**
   * The name of the column
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "The name of the column")
  public String getName() {
    return name;
  }

   /**
   * The column's type
   * @return type
  **/
  @ApiModelProperty(example = "null", value = "The column's type")
  public TypeEnum getType() {
    return type;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ColumnInfoDto columnInfoDto = (ColumnInfoDto) o;
    return Objects.equals(this.name, columnInfoDto.name) &&
        Objects.equals(this.type, columnInfoDto.type);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, type);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ColumnInfoDto {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

