/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.joda.time.DateTime;


/**
 * ConnectionRunDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class ConnectionRunDto   {
  @SerializedName("connectionId")
  private String connectionId = null;

  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("createdBy")
  private String createdBy = null;

  @SerializedName("destinationParameters")
  private Object destinationParameters = null;

  /**
   * The run status of the destination
   */
  public enum DestinationStatusEnum {
    @SerializedName("not_started")
    NOT_STARTED("not_started"),
    
    @SerializedName("running")
    RUNNING("running"),
    
    @SerializedName("complete")
    COMPLETE("complete"),
    
    @SerializedName("error")
    ERROR("error"),
    
    @SerializedName("cancelled")
    CANCELLED("cancelled");

    private String value;

    DestinationStatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("destinationStatus")
  private DestinationStatusEnum destinationStatus = null;

  @SerializedName("error")
  private String error = null;

  @SerializedName("jobId")
  private String jobId = null;

  @SerializedName("sourceParameters")
  private Object sourceParameters = null;

  /**
   * The run status of the source
   */
  public enum SourceStatusEnum {
    @SerializedName("not_started")
    NOT_STARTED("not_started"),
    
    @SerializedName("running")
    RUNNING("running"),
    
    @SerializedName("complete")
    COMPLETE("complete"),
    
    @SerializedName("error")
    ERROR("error"),
    
    @SerializedName("cancelled")
    CANCELLED("cancelled");

    private String value;

    SourceStatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("sourceStatus")
  private SourceStatusEnum sourceStatus = null;

  @SerializedName("updated")
  private DateTime updated = null;

   /**
   * The unique ID of the connection
   * @return connectionId
  **/
  @ApiModelProperty(example = "null", value = "The unique ID of the connection")
  public String getConnectionId() {
    return connectionId;
  }

   /**
   * When the connection was created, as a datetime
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the connection was created, as a datetime")
  public DateTime getCreated() {
    return created;
  }

   /**
   * The ID of the user that created the connection
   * @return createdBy
  **/
  @ApiModelProperty(example = "null", value = "The ID of the user that created the connection")
  public String getCreatedBy() {
    return createdBy;
  }

  public ConnectionRunDto destinationParameters(Object destinationParameters) {
    this.destinationParameters = destinationParameters;
    return this;
  }

   /**
   * Any parameters provided to the destination
   * @return destinationParameters
  **/
  @ApiModelProperty(example = "null", value = "Any parameters provided to the destination")
  public Object getDestinationParameters() {
    return destinationParameters;
  }

  public void setDestinationParameters(Object destinationParameters) {
    this.destinationParameters = destinationParameters;
  }

   /**
   * The run status of the destination
   * @return destinationStatus
  **/
  @ApiModelProperty(example = "null", value = "The run status of the destination")
  public DestinationStatusEnum getDestinationStatus() {
    return destinationStatus;
  }

   /**
   * An error, if encountered, while initiating the job
   * @return error
  **/
  @ApiModelProperty(example = "null", value = "An error, if encountered, while initiating the job")
  public String getError() {
    return error;
  }

   /**
   * The unique ID of the job
   * @return jobId
  **/
  @ApiModelProperty(example = "null", value = "The unique ID of the job")
  public String getJobId() {
    return jobId;
  }

  public ConnectionRunDto sourceParameters(Object sourceParameters) {
    this.sourceParameters = sourceParameters;
    return this;
  }

   /**
   * Any parameters provided to the source
   * @return sourceParameters
  **/
  @ApiModelProperty(example = "null", value = "Any parameters provided to the source")
  public Object getSourceParameters() {
    return sourceParameters;
  }

  public void setSourceParameters(Object sourceParameters) {
    this.sourceParameters = sourceParameters;
  }

   /**
   * The run status of the source
   * @return sourceStatus
  **/
  @ApiModelProperty(example = "null", value = "The run status of the source")
  public SourceStatusEnum getSourceStatus() {
    return sourceStatus;
  }

   /**
   * When the connection was updated, as a datetime
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the connection was updated, as a datetime")
  public DateTime getUpdated() {
    return updated;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ConnectionRunDto connectionRunDto = (ConnectionRunDto) o;
    return Objects.equals(this.connectionId, connectionRunDto.connectionId) &&
        Objects.equals(this.created, connectionRunDto.created) &&
        Objects.equals(this.createdBy, connectionRunDto.createdBy) &&
        Objects.equals(this.destinationParameters, connectionRunDto.destinationParameters) &&
        Objects.equals(this.destinationStatus, connectionRunDto.destinationStatus) &&
        Objects.equals(this.error, connectionRunDto.error) &&
        Objects.equals(this.jobId, connectionRunDto.jobId) &&
        Objects.equals(this.sourceParameters, connectionRunDto.sourceParameters) &&
        Objects.equals(this.sourceStatus, connectionRunDto.sourceStatus) &&
        Objects.equals(this.updated, connectionRunDto.updated);
  }

  @Override
  public int hashCode() {
    return Objects.hash(connectionId, created, createdBy, destinationParameters, destinationStatus, error, jobId, sourceParameters, sourceStatus, updated);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ConnectionRunDto {\n");
    
    sb.append("    connectionId: ").append(toIndentedString(connectionId)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    createdBy: ").append(toIndentedString(createdBy)).append("\n");
    sb.append("    destinationParameters: ").append(toIndentedString(destinationParameters)).append("\n");
    sb.append("    destinationStatus: ").append(toIndentedString(destinationStatus)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("    jobId: ").append(toIndentedString(jobId)).append("\n");
    sb.append("    sourceParameters: ").append(toIndentedString(sourceParameters)).append("\n");
    sb.append("    sourceStatus: ").append(toIndentedString(sourceStatus)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

