/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.joda.time.DateTime;


/**
 * FolderableDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class FolderableDto   {
  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("metadata")
  private Object metadata = null;

  @SerializedName("modified")
  private DateTime modified = null;

  @SerializedName("modifiedBy")
  private String modifiedBy = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("parentId")
  private String parentId = null;

  @SerializedName("type")
  private Integer type = null;

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("updatedBy")
  private String updatedBy = null;

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

   /**
   * A description of the folderable entity
   * @return description
  **/
  @ApiModelProperty(example = "null", value = "A description of the folderable entity")
  public String getDescription() {
    return description;
  }

  public FolderableDto id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The UUID unique identifier for the entity.
   * @return id
  **/
  @ApiModelProperty(example = "null", required = true, value = "The UUID unique identifier for the entity.")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public FolderableDto metadata(Object metadata) {
    this.metadata = metadata;
    return this;
  }

   /**
   * Contains additional metadata about the entity returned. For example, a table entity might have a type attribute.
   * @return metadata
  **/
  @ApiModelProperty(example = "null", value = "Contains additional metadata about the entity returned. For example, a table entity might have a type attribute.")
  public Object getMetadata() {
    return metadata;
  }

  public void setMetadata(Object metadata) {
    this.metadata = metadata;
  }

   /**
   * When a significant event happened on the data object.  For example, for queries, this is when the last run occurred; for tables, this is when the last upload occurred.
   * @return modified
  **/
  @ApiModelProperty(example = "null", value = "When a significant event happened on the data object.  For example, for queries, this is when the last run occurred; for tables, this is when the last upload occurred.")
  public DateTime getModified() {
    return modified;
  }

   /**
   * The identifier of the user who last modified the entity
   * @return modifiedBy
  **/
  @ApiModelProperty(example = "null", value = "The identifier of the user who last modified the entity")
  public String getModifiedBy() {
    return modifiedBy;
  }

   /**
   * The name of the folderable entity
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "The name of the folderable entity")
  public String getName() {
    return name;
  }

   /**
   * The ID of the folder to which this entity belongs. This can be null if the entity is not in a folder.
   * @return parentId
  **/
  @ApiModelProperty(example = "null", value = "The ID of the folder to which this entity belongs. This can be null if the entity is not in a folder.")
  public String getParentId() {
    return parentId;
  }

  public FolderableDto type(Integer type) {
    this.type = type;
    return this;
  }

   /**
   * The numerical identifier for the entity's type:  Query=100, Table=200, Pivot View=500, Folder=600, Shared Table=700
   * @return type
  **/
  @ApiModelProperty(example = "null", required = true, value = "The numerical identifier for the entity's type:  Query=100, Table=200, Pivot View=500, Folder=600, Shared Table=700")
  public Integer getType() {
    return type;
  }

  public void setType(Integer type) {
    this.type = type;
  }

   /**
   * When the data object was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the data object was last updated")
  public DateTime getUpdated() {
    return updated;
  }

   /**
   * The identifier of the user who last updated the entity
   * @return updatedBy
  **/
  @ApiModelProperty(example = "null", value = "The identifier of the user who last updated the entity")
  public String getUpdatedBy() {
    return updatedBy;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FolderableDto folderableDto = (FolderableDto) o;
    return Objects.equals(this.created, folderableDto.created) &&
        Objects.equals(this.description, folderableDto.description) &&
        Objects.equals(this.id, folderableDto.id) &&
        Objects.equals(this.metadata, folderableDto.metadata) &&
        Objects.equals(this.modified, folderableDto.modified) &&
        Objects.equals(this.modifiedBy, folderableDto.modifiedBy) &&
        Objects.equals(this.name, folderableDto.name) &&
        Objects.equals(this.parentId, folderableDto.parentId) &&
        Objects.equals(this.type, folderableDto.type) &&
        Objects.equals(this.updated, folderableDto.updated) &&
        Objects.equals(this.updatedBy, folderableDto.updatedBy);
  }

  @Override
  public int hashCode() {
    return Objects.hash(created, description, id, metadata, modified, modifiedBy, name, parentId, type, updated, updatedBy);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FolderableDto {\n");
    
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    modified: ").append(toIndentedString(modified)).append("\n");
    sb.append("    modifiedBy: ").append(toIndentedString(modifiedBy)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    parentId: ").append(toIndentedString(parentId)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    updatedBy: ").append(toIndentedString(updatedBy)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

