/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * ImportDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class ImportDto   {
  @SerializedName("columnMappings")
  private Map<String, String> columnMappings = new HashMap<String, String>();

  @SerializedName("delimiter")
  private String delimiter = null;

  @SerializedName("fileId")
  private String fileId = null;

  @SerializedName("metadata")
  private Map<String, Map<String, Object>> metadata = new HashMap<String, Map<String, Object>>();

  @SerializedName("tags")
  private Map<String, String> tags = new HashMap<String, String>();

  public ImportDto columnMappings(Map<String, String> columnMappings) {
    this.columnMappings = columnMappings;
    return this;
  }

  public ImportDto putColumnMappingsItem(String key, String columnMappingsItem) {
    this.columnMappings.put(key, columnMappingsItem);
    return this;
  }

   /**
   * a map of import column names to table column ids
   * @return columnMappings
  **/
  @ApiModelProperty(example = "null", value = "a map of import column names to table column ids")
  public Map<String, String> getColumnMappings() {
    return columnMappings;
  }

  public void setColumnMappings(Map<String, String> columnMappings) {
    this.columnMappings = columnMappings;
  }

  public ImportDto delimiter(String delimiter) {
    this.delimiter = delimiter;
    return this;
  }

   /**
   * For overriding the file metadata's delimiter. The file delimiter is the character to use within the file to separate one field from another. If this value is not set, the import will use the file's set delimiter. If this value is set, the file metadata's delimiter will be updated on the file object.
   * @return delimiter
  **/
  @ApiModelProperty(example = "null", value = "For overriding the file metadata's delimiter. The file delimiter is the character to use within the file to separate one field from another. If this value is not set, the import will use the file's set delimiter. If this value is set, the file metadata's delimiter will be updated on the file object.")
  public String getDelimiter() {
    return delimiter;
  }

  public void setDelimiter(String delimiter) {
    this.delimiter = delimiter;
  }

  public ImportDto fileId(String fileId) {
    this.fileId = fileId;
    return this;
  }

   /**
   * id of the file to import to the table
   * @return fileId
  **/
  @ApiModelProperty(example = "null", required = true, value = "id of the file to import to the table")
  public String getFileId() {
    return fileId;
  }

  public void setFileId(String fileId) {
    this.fileId = fileId;
  }

  public ImportDto metadata(Map<String, Map<String, Object>> metadata) {
    this.metadata = metadata;
    return this;
  }

  public ImportDto putMetadataItem(String key, Map<String, Object> metadataItem) {
    this.metadata.put(key, metadataItem);
    return this;
  }

   /**
   * For overriding column metadata specifically for this import. The keys in this object are column identifiers with the values being metadata objects.
   * @return metadata
  **/
  @ApiModelProperty(example = "null", value = "For overriding column metadata specifically for this import. The keys in this object are column identifiers with the values being metadata objects.")
  public Map<String, Map<String, Object>> getMetadata() {
    return metadata;
  }

  public void setMetadata(Map<String, Map<String, Object>> metadata) {
    this.metadata = metadata;
  }

  public ImportDto tags(Map<String, String> tags) {
    this.tags = tags;
    return this;
  }

  public ImportDto putTagsItem(String key, String tagsItem) {
    this.tags.put(key, tagsItem);
    return this;
  }

   /**
   * an object containing keys and values, which becomes the tag map
   * @return tags
  **/
  @ApiModelProperty(example = "null", value = "an object containing keys and values, which becomes the tag map")
  public Map<String, String> getTags() {
    return tags;
  }

  public void setTags(Map<String, String> tags) {
    this.tags = tags;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ImportDto importDto = (ImportDto) o;
    return Objects.equals(this.columnMappings, importDto.columnMappings) &&
        Objects.equals(this.delimiter, importDto.delimiter) &&
        Objects.equals(this.fileId, importDto.fileId) &&
        Objects.equals(this.metadata, importDto.metadata) &&
        Objects.equals(this.tags, importDto.tags);
  }

  @Override
  public int hashCode() {
    return Objects.hash(columnMappings, delimiter, fileId, metadata, tags);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ImportDto {\n");
    
    sb.append("    columnMappings: ").append(toIndentedString(columnMappings)).append("\n");
    sb.append("    delimiter: ").append(toIndentedString(delimiter)).append("\n");
    sb.append("    fileId: ").append(toIndentedString(fileId)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

