/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.PivotViewDefinitionColumnDto;
import io.swagger.client.model.PivotViewDefinitionFilterDto;
import io.swagger.client.model.PivotViewDefinitionRowDto;
import io.swagger.client.model.PivotViewDefinitionValueDto;
import java.util.ArrayList;
import java.util.List;


/**
 * PivotDefinitionDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class PivotDefinitionDto   {
  @SerializedName("columns")
  private List<PivotViewDefinitionColumnDto> columns = new ArrayList<PivotViewDefinitionColumnDto>();

  @SerializedName("decimalPlaces")
  private Integer decimalPlaces = null;

  @SerializedName("filters")
  private List<PivotViewDefinitionFilterDto> filters = new ArrayList<PivotViewDefinitionFilterDto>();

  /**
   * The level to which Grand Totals are enabled.  It is defaulted to DISABLED.
   */
  public enum GrandTotalEnabledEnum {
    @SerializedName("ENABLED")
    ENABLED("ENABLED"),
    
    @SerializedName("ROW")
    ROW("ROW"),
    
    @SerializedName("COLUMN")
    COLUMN("COLUMN"),
    
    @SerializedName("DISABLED")
    DISABLED("DISABLED");

    private String value;

    GrandTotalEnabledEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("grandTotalEnabled")
  private GrandTotalEnabledEnum grandTotalEnabled = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("multipleHeaders")
  private Boolean multipleHeaders = null;

  /**
   * The type of pivot view. Options are currently Classic and Compact.
   */
  public enum PivotViewTypeEnum {
    @SerializedName("CLASSIC")
    CLASSIC("CLASSIC"),
    
    @SerializedName("COMPACT")
    COMPACT("COMPACT"),
    
    @SerializedName("FLAT")
    FLAT("FLAT");

    private String value;

    PivotViewTypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("pivotViewType")
  private PivotViewTypeEnum pivotViewType = null;

  @SerializedName("rows")
  private List<PivotViewDefinitionRowDto> rows = new ArrayList<PivotViewDefinitionRowDto>();

  @SerializedName("sortColumns")
  private List<String> sortColumns = new ArrayList<String>();

  /**
   * The level to which Subtotals are enabled.  It is defaulted to DISABLED.
   */
  public enum SubtotalEnabledEnum {
    @SerializedName("ENABLED")
    ENABLED("ENABLED"),
    
    @SerializedName("ROW")
    ROW("ROW"),
    
    @SerializedName("COLUMN")
    COLUMN("COLUMN"),
    
    @SerializedName("DISABLED")
    DISABLED("DISABLED");

    private String value;

    SubtotalEnabledEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("subtotalEnabled")
  private SubtotalEnabledEnum subtotalEnabled = null;

  @SerializedName("values")
  private List<PivotViewDefinitionValueDto> values = new ArrayList<PivotViewDefinitionValueDto>();

  public PivotDefinitionDto columns(List<PivotViewDefinitionColumnDto> columns) {
    this.columns = columns;
    return this;
  }

  public PivotDefinitionDto addColumnsItem(PivotViewDefinitionColumnDto columnsItem) {
    this.columns.add(columnsItem);
    return this;
  }

   /**
   * The colmnnns associated with the pivot view
   * @return columns
  **/
  @ApiModelProperty(example = "null", value = "The colmnnns associated with the pivot view")
  public List<PivotViewDefinitionColumnDto> getColumns() {
    return columns;
  }

  public void setColumns(List<PivotViewDefinitionColumnDto> columns) {
    this.columns = columns;
  }

  public PivotDefinitionDto decimalPlaces(Integer decimalPlaces) {
    this.decimalPlaces = decimalPlaces;
    return this;
  }

   /**
   * Numeric data values are rounded to the number of decimal places.  The default number to round to and show is 2 decimal places, and the maximum number is capped at 16.
   * minimum: 0.0
   * maximum: 16.0
   * @return decimalPlaces
  **/
  @ApiModelProperty(example = "null", value = "Numeric data values are rounded to the number of decimal places.  The default number to round to and show is 2 decimal places, and the maximum number is capped at 16.")
  public Integer getDecimalPlaces() {
    return decimalPlaces;
  }

  public void setDecimalPlaces(Integer decimalPlaces) {
    this.decimalPlaces = decimalPlaces;
  }

  public PivotDefinitionDto filters(List<PivotViewDefinitionFilterDto> filters) {
    this.filters = filters;
    return this;
  }

  public PivotDefinitionDto addFiltersItem(PivotViewDefinitionFilterDto filtersItem) {
    this.filters.add(filtersItem);
    return this;
  }

   /**
   * The filters associated with the pivot view
   * @return filters
  **/
  @ApiModelProperty(example = "null", value = "The filters associated with the pivot view")
  public List<PivotViewDefinitionFilterDto> getFilters() {
    return filters;
  }

  public void setFilters(List<PivotViewDefinitionFilterDto> filters) {
    this.filters = filters;
  }

  public PivotDefinitionDto grandTotalEnabled(GrandTotalEnabledEnum grandTotalEnabled) {
    this.grandTotalEnabled = grandTotalEnabled;
    return this;
  }

   /**
   * The level to which Grand Totals are enabled.  It is defaulted to DISABLED.
   * @return grandTotalEnabled
  **/
  @ApiModelProperty(example = "null", value = "The level to which Grand Totals are enabled.  It is defaulted to DISABLED.")
  public GrandTotalEnabledEnum getGrandTotalEnabled() {
    return grandTotalEnabled;
  }

  public void setGrandTotalEnabled(GrandTotalEnabledEnum grandTotalEnabled) {
    this.grandTotalEnabled = grandTotalEnabled;
  }

  public PivotDefinitionDto id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The pivot view's definition's id
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The pivot view's definition's id")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public PivotDefinitionDto multipleHeaders(Boolean multipleHeaders) {
    this.multipleHeaders = multipleHeaders;
    return this;
  }

   /**
   * Denotes whether a pivot is created in multi-line header mode. Default is false.
   * @return multipleHeaders
  **/
  @ApiModelProperty(example = "false", value = "Denotes whether a pivot is created in multi-line header mode. Default is false.")
  public Boolean getMultipleHeaders() {
    return multipleHeaders;
  }

  public void setMultipleHeaders(Boolean multipleHeaders) {
    this.multipleHeaders = multipleHeaders;
  }

  public PivotDefinitionDto pivotViewType(PivotViewTypeEnum pivotViewType) {
    this.pivotViewType = pivotViewType;
    return this;
  }

   /**
   * The type of pivot view. Options are currently Classic and Compact.
   * @return pivotViewType
  **/
  @ApiModelProperty(example = "null", value = "The type of pivot view. Options are currently Classic and Compact.")
  public PivotViewTypeEnum getPivotViewType() {
    return pivotViewType;
  }

  public void setPivotViewType(PivotViewTypeEnum pivotViewType) {
    this.pivotViewType = pivotViewType;
  }

  public PivotDefinitionDto rows(List<PivotViewDefinitionRowDto> rows) {
    this.rows = rows;
    return this;
  }

  public PivotDefinitionDto addRowsItem(PivotViewDefinitionRowDto rowsItem) {
    this.rows.add(rowsItem);
    return this;
  }

   /**
   * The rows associated with the pivot view
   * @return rows
  **/
  @ApiModelProperty(example = "null", value = "The rows associated with the pivot view")
  public List<PivotViewDefinitionRowDto> getRows() {
    return rows;
  }

  public void setRows(List<PivotViewDefinitionRowDto> rows) {
    this.rows = rows;
  }

  public PivotDefinitionDto sortColumns(List<String> sortColumns) {
    this.sortColumns = sortColumns;
    return this;
  }

  public PivotDefinitionDto addSortColumnsItem(String sortColumnsItem) {
    this.sortColumns.add(sortColumnsItem);
    return this;
  }

   /**
   * Columns with which to sort the crosstab query
   * @return sortColumns
  **/
  @ApiModelProperty(example = "null", value = "Columns with which to sort the crosstab query")
  public List<String> getSortColumns() {
    return sortColumns;
  }

  public void setSortColumns(List<String> sortColumns) {
    this.sortColumns = sortColumns;
  }

  public PivotDefinitionDto subtotalEnabled(SubtotalEnabledEnum subtotalEnabled) {
    this.subtotalEnabled = subtotalEnabled;
    return this;
  }

   /**
   * The level to which Subtotals are enabled.  It is defaulted to DISABLED.
   * @return subtotalEnabled
  **/
  @ApiModelProperty(example = "null", value = "The level to which Subtotals are enabled.  It is defaulted to DISABLED.")
  public SubtotalEnabledEnum getSubtotalEnabled() {
    return subtotalEnabled;
  }

  public void setSubtotalEnabled(SubtotalEnabledEnum subtotalEnabled) {
    this.subtotalEnabled = subtotalEnabled;
  }

  public PivotDefinitionDto values(List<PivotViewDefinitionValueDto> values) {
    this.values = values;
    return this;
  }

  public PivotDefinitionDto addValuesItem(PivotViewDefinitionValueDto valuesItem) {
    this.values.add(valuesItem);
    return this;
  }

   /**
   * The values associated with the pivot view
   * @return values
  **/
  @ApiModelProperty(example = "null", value = "The values associated with the pivot view")
  public List<PivotViewDefinitionValueDto> getValues() {
    return values;
  }

  public void setValues(List<PivotViewDefinitionValueDto> values) {
    this.values = values;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PivotDefinitionDto pivotDefinitionDto = (PivotDefinitionDto) o;
    return Objects.equals(this.columns, pivotDefinitionDto.columns) &&
        Objects.equals(this.decimalPlaces, pivotDefinitionDto.decimalPlaces) &&
        Objects.equals(this.filters, pivotDefinitionDto.filters) &&
        Objects.equals(this.grandTotalEnabled, pivotDefinitionDto.grandTotalEnabled) &&
        Objects.equals(this.id, pivotDefinitionDto.id) &&
        Objects.equals(this.multipleHeaders, pivotDefinitionDto.multipleHeaders) &&
        Objects.equals(this.pivotViewType, pivotDefinitionDto.pivotViewType) &&
        Objects.equals(this.rows, pivotDefinitionDto.rows) &&
        Objects.equals(this.sortColumns, pivotDefinitionDto.sortColumns) &&
        Objects.equals(this.subtotalEnabled, pivotDefinitionDto.subtotalEnabled) &&
        Objects.equals(this.values, pivotDefinitionDto.values);
  }

  @Override
  public int hashCode() {
    return Objects.hash(columns, decimalPlaces, filters, grandTotalEnabled, id, multipleHeaders, pivotViewType, rows, sortColumns, subtotalEnabled, values);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PivotDefinitionDto {\n");
    
    sb.append("    columns: ").append(toIndentedString(columns)).append("\n");
    sb.append("    decimalPlaces: ").append(toIndentedString(decimalPlaces)).append("\n");
    sb.append("    filters: ").append(toIndentedString(filters)).append("\n");
    sb.append("    grandTotalEnabled: ").append(toIndentedString(grandTotalEnabled)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    multipleHeaders: ").append(toIndentedString(multipleHeaders)).append("\n");
    sb.append("    pivotViewType: ").append(toIndentedString(pivotViewType)).append("\n");
    sb.append("    rows: ").append(toIndentedString(rows)).append("\n");
    sb.append("    sortColumns: ").append(toIndentedString(sortColumns)).append("\n");
    sb.append("    subtotalEnabled: ").append(toIndentedString(subtotalEnabled)).append("\n");
    sb.append("    values: ").append(toIndentedString(values)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

