/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * PivotViewDefinitionFilterDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class PivotViewDefinitionFilterDto   {
  @SerializedName("betweenValue")
  private String betweenValue = null;

  /**
   * The column type.
   */
  public enum ColumnTypeEnum {
    @SerializedName("integer")
    INTEGER("integer"),
    
    @SerializedName("number")
    NUMBER("number"),
    
    @SerializedName("boolean")
    BOOLEAN("boolean"),
    
    @SerializedName("timestamp")
    TIMESTAMP("timestamp"),
    
    @SerializedName("date")
    DATE("date"),
    
    @SerializedName("string")
    STRING("string"),
    
    @SerializedName("float")
    FLOAT("float");

    private String value;

    ColumnTypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("columnType")
  private ColumnTypeEnum columnType = null;

  @SerializedName("exclude")
  private Boolean exclude = null;

  /**
   * The filter to perform.
   */
  public enum FilterEnum {
    @SerializedName("EQUAL")
    EQUAL("EQUAL"),
    
    @SerializedName("NOT_EQUAL")
    NOT_EQUAL("NOT_EQUAL"),
    
    @SerializedName("GREATER")
    GREATER("GREATER"),
    
    @SerializedName("GREATER_OR_EQUAL")
    GREATER_OR_EQUAL("GREATER_OR_EQUAL"),
    
    @SerializedName("LESS")
    LESS("LESS"),
    
    @SerializedName("LESS_OR_EQUAL")
    LESS_OR_EQUAL("LESS_OR_EQUAL"),
    
    @SerializedName("BETWEEN")
    BETWEEN("BETWEEN"),
    
    @SerializedName("NOT_BETWEEN")
    NOT_BETWEEN("NOT_BETWEEN");

    private String value;

    FilterEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("filter")
  private FilterEnum filter = null;

  @SerializedName("filterValues")
  private List<String> filterValues = new ArrayList<String>();

  @SerializedName("name")
  private String name = null;

  @SerializedName("value")
  private String value = null;

  public PivotViewDefinitionFilterDto betweenValue(String betweenValue) {
    this.betweenValue = betweenValue;
    return this;
  }

   /**
   * A second value for 'between' filters
   * @return betweenValue
  **/
  @ApiModelProperty(example = "null", value = "A second value for 'between' filters")
  public String getBetweenValue() {
    return betweenValue;
  }

  public void setBetweenValue(String betweenValue) {
    this.betweenValue = betweenValue;
  }

  public PivotViewDefinitionFilterDto columnType(ColumnTypeEnum columnType) {
    this.columnType = columnType;
    return this;
  }

   /**
   * The column type.
   * @return columnType
  **/
  @ApiModelProperty(example = "null", required = true, value = "The column type.")
  public ColumnTypeEnum getColumnType() {
    return columnType;
  }

  public void setColumnType(ColumnTypeEnum columnType) {
    this.columnType = columnType;
  }

  public PivotViewDefinitionFilterDto exclude(Boolean exclude) {
    this.exclude = exclude;
    return this;
  }

   /**
   * True if value list is exclude, false if value list is include. Defaults to true.
   * @return exclude
  **/
  @ApiModelProperty(example = "false", value = "True if value list is exclude, false if value list is include. Defaults to true.")
  public Boolean getExclude() {
    return exclude;
  }

  public void setExclude(Boolean exclude) {
    this.exclude = exclude;
  }

  public PivotViewDefinitionFilterDto filter(FilterEnum filter) {
    this.filter = filter;
    return this;
  }

   /**
   * The filter to perform.
   * @return filter
  **/
  @ApiModelProperty(example = "null", value = "The filter to perform.")
  public FilterEnum getFilter() {
    return filter;
  }

  public void setFilter(FilterEnum filter) {
    this.filter = filter;
  }

  public PivotViewDefinitionFilterDto filterValues(List<String> filterValues) {
    this.filterValues = filterValues;
    return this;
  }

  public PivotViewDefinitionFilterDto addFilterValuesItem(String filterValuesItem) {
    this.filterValues.add(filterValuesItem);
    return this;
  }

   /**
   * The values obtained after applying the filter
   * @return filterValues
  **/
  @ApiModelProperty(example = "null", value = "The values obtained after applying the filter")
  public List<String> getFilterValues() {
    return filterValues;
  }

  public void setFilterValues(List<String> filterValues) {
    this.filterValues = filterValues;
  }

  public PivotViewDefinitionFilterDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The column for the pivot view filter. The maximum size is 255 characters.
   * @return name
  **/
  @ApiModelProperty(example = "null", required = true, value = "The column for the pivot view filter. The maximum size is 255 characters.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public PivotViewDefinitionFilterDto value(String value) {
    this.value = value;
    return this;
  }

   /**
   * The value to filter on.
   * @return value
  **/
  @ApiModelProperty(example = "null", value = "The value to filter on.")
  public String getValue() {
    return value;
  }

  public void setValue(String value) {
    this.value = value;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PivotViewDefinitionFilterDto pivotViewDefinitionFilterDto = (PivotViewDefinitionFilterDto) o;
    return Objects.equals(this.betweenValue, pivotViewDefinitionFilterDto.betweenValue) &&
        Objects.equals(this.columnType, pivotViewDefinitionFilterDto.columnType) &&
        Objects.equals(this.exclude, pivotViewDefinitionFilterDto.exclude) &&
        Objects.equals(this.filter, pivotViewDefinitionFilterDto.filter) &&
        Objects.equals(this.filterValues, pivotViewDefinitionFilterDto.filterValues) &&
        Objects.equals(this.name, pivotViewDefinitionFilterDto.name) &&
        Objects.equals(this.value, pivotViewDefinitionFilterDto.value);
  }

  @Override
  public int hashCode() {
    return Objects.hash(betweenValue, columnType, exclude, filter, filterValues, name, value);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PivotViewDefinitionFilterDto {\n");
    
    sb.append("    betweenValue: ").append(toIndentedString(betweenValue)).append("\n");
    sb.append("    columnType: ").append(toIndentedString(columnType)).append("\n");
    sb.append("    exclude: ").append(toIndentedString(exclude)).append("\n");
    sb.append("    filter: ").append(toIndentedString(filter)).append("\n");
    sb.append("    filterValues: ").append(toIndentedString(filterValues)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    value: ").append(toIndentedString(value)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

