/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * PivotViewDefinitionValueDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class PivotViewDefinitionValueDto   {
  @SerializedName("active")
  private Boolean active = null;

  /**
   * The aggregation type to apply to the pivot view value
   */
  public enum AggregationEnum {
    @SerializedName("sum")
    SUM("sum"),
    
    @SerializedName("count")
    COUNT("count"),
    
    @SerializedName("distinctcount")
    DISTINCTCOUNT("distinctcount"),
    
    @SerializedName("average")
    AVERAGE("average"),
    
    @SerializedName("median")
    MEDIAN("median"),
    
    @SerializedName("product")
    PRODUCT("product"),
    
    @SerializedName("min")
    MIN("min"),
    
    @SerializedName("max")
    MAX("max"),
    
    @SerializedName("percent")
    PERCENT("percent"),
    
    @SerializedName("percentofcolumn")
    PERCENTOFCOLUMN("percentofcolumn"),
    
    @SerializedName("percentofrow")
    PERCENTOFROW("percentofrow"),
    
    @SerializedName("difference")
    DIFFERENCE("difference"),
    
    @SerializedName("percentdifference")
    PERCENTDIFFERENCE("percentdifference"),
    
    @SerializedName("runningtotals")
    RUNNINGTOTALS("runningtotals"),
    
    @SerializedName("stdevp")
    STDEVP("stdevp"),
    
    @SerializedName("stdevs")
    STDEVS("stdevs");

    private String value;

    AggregationEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("aggregation")
  private AggregationEnum aggregation = null;

  /**
   * The column type.
   */
  public enum ColumnTypeEnum {
    @SerializedName("integer")
    INTEGER("integer"),
    
    @SerializedName("number")
    NUMBER("number"),
    
    @SerializedName("boolean")
    BOOLEAN("boolean"),
    
    @SerializedName("timestamp")
    TIMESTAMP("timestamp"),
    
    @SerializedName("date")
    DATE("date"),
    
    @SerializedName("string")
    STRING("string"),
    
    @SerializedName("float")
    FLOAT("float");

    private String value;

    ColumnTypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("columnType")
  private ColumnTypeEnum columnType = null;

  @SerializedName("name")
  private String name = null;

  public PivotViewDefinitionValueDto active(Boolean active) {
    this.active = active;
    return this;
  }

   /**
   * Get active
   * @return active
  **/
  @ApiModelProperty(example = "null", required = true, value = "")
  public Boolean getActive() {
    return active;
  }

  public void setActive(Boolean active) {
    this.active = active;
  }

  public PivotViewDefinitionValueDto aggregation(AggregationEnum aggregation) {
    this.aggregation = aggregation;
    return this;
  }

   /**
   * The aggregation type to apply to the pivot view value
   * @return aggregation
  **/
  @ApiModelProperty(example = "null", required = true, value = "The aggregation type to apply to the pivot view value")
  public AggregationEnum getAggregation() {
    return aggregation;
  }

  public void setAggregation(AggregationEnum aggregation) {
    this.aggregation = aggregation;
  }

  public PivotViewDefinitionValueDto columnType(ColumnTypeEnum columnType) {
    this.columnType = columnType;
    return this;
  }

   /**
   * The column type.
   * @return columnType
  **/
  @ApiModelProperty(example = "null", value = "The column type.")
  public ColumnTypeEnum getColumnType() {
    return columnType;
  }

  public void setColumnType(ColumnTypeEnum columnType) {
    this.columnType = columnType;
  }

  public PivotViewDefinitionValueDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the pivot view value. The maximum size is 255 characters.
   * @return name
  **/
  @ApiModelProperty(example = "null", required = true, value = "Name of the pivot view value. The maximum size is 255 characters.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PivotViewDefinitionValueDto pivotViewDefinitionValueDto = (PivotViewDefinitionValueDto) o;
    return Objects.equals(this.active, pivotViewDefinitionValueDto.active) &&
        Objects.equals(this.aggregation, pivotViewDefinitionValueDto.aggregation) &&
        Objects.equals(this.columnType, pivotViewDefinitionValueDto.columnType) &&
        Objects.equals(this.name, pivotViewDefinitionValueDto.name);
  }

  @Override
  public int hashCode() {
    return Objects.hash(active, aggregation, columnType, name);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PivotViewDefinitionValueDto {\n");
    
    sb.append("    active: ").append(toIndentedString(active)).append("\n");
    sb.append("    aggregation: ").append(toIndentedString(aggregation)).append("\n");
    sb.append("    columnType: ").append(toIndentedString(columnType)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

