/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * RefreshConnectionDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class RefreshConnectionDto   {
  @SerializedName("connectionId")
  private String connectionId = null;

  @SerializedName("destinationParameters")
  private Object destinationParameters = null;

  @SerializedName("sourceParameters")
  private Object sourceParameters = null;

  @SerializedName("usePreviousDestinationParameters")
  private Boolean usePreviousDestinationParameters = null;

  @SerializedName("usePreviousSourceParameters")
  private Boolean usePreviousSourceParameters = null;

  public RefreshConnectionDto connectionId(String connectionId) {
    this.connectionId = connectionId;
    return this;
  }

   /**
   * The unique ID of the connection
   * @return connectionId
  **/
  @ApiModelProperty(example = "null", value = "The unique ID of the connection")
  public String getConnectionId() {
    return connectionId;
  }

  public void setConnectionId(String connectionId) {
    this.connectionId = connectionId;
  }

  public RefreshConnectionDto destinationParameters(Object destinationParameters) {
    this.destinationParameters = destinationParameters;
    return this;
  }

   /**
   * Parameters to send to the destination, on refresh
   * @return destinationParameters
  **/
  @ApiModelProperty(example = "null", value = "Parameters to send to the destination, on refresh")
  public Object getDestinationParameters() {
    return destinationParameters;
  }

  public void setDestinationParameters(Object destinationParameters) {
    this.destinationParameters = destinationParameters;
  }

  public RefreshConnectionDto sourceParameters(Object sourceParameters) {
    this.sourceParameters = sourceParameters;
    return this;
  }

   /**
   * Parameters to send to the source, on refresh
   * @return sourceParameters
  **/
  @ApiModelProperty(example = "null", value = "Parameters to send to the source, on refresh")
  public Object getSourceParameters() {
    return sourceParameters;
  }

  public void setSourceParameters(Object sourceParameters) {
    this.sourceParameters = sourceParameters;
  }

  public RefreshConnectionDto usePreviousDestinationParameters(Boolean usePreviousDestinationParameters) {
    this.usePreviousDestinationParameters = usePreviousDestinationParameters;
    return this;
  }

   /**
   * Use the destination parameters from the previous run. This overrides any specified destination parameters. Ignored by \"Refresh batch of connections\" endpoint
   * @return usePreviousDestinationParameters
  **/
  @ApiModelProperty(example = "false", value = "Use the destination parameters from the previous run. This overrides any specified destination parameters. Ignored by \"Refresh batch of connections\" endpoint")
  public Boolean getUsePreviousDestinationParameters() {
    return usePreviousDestinationParameters;
  }

  public void setUsePreviousDestinationParameters(Boolean usePreviousDestinationParameters) {
    this.usePreviousDestinationParameters = usePreviousDestinationParameters;
  }

  public RefreshConnectionDto usePreviousSourceParameters(Boolean usePreviousSourceParameters) {
    this.usePreviousSourceParameters = usePreviousSourceParameters;
    return this;
  }

   /**
   * Use the source parameters from the previous run. This overrides any specified source parameters. Ignored by \"Refresh batch of connections\" endpoint
   * @return usePreviousSourceParameters
  **/
  @ApiModelProperty(example = "false", value = "Use the source parameters from the previous run. This overrides any specified source parameters. Ignored by \"Refresh batch of connections\" endpoint")
  public Boolean getUsePreviousSourceParameters() {
    return usePreviousSourceParameters;
  }

  public void setUsePreviousSourceParameters(Boolean usePreviousSourceParameters) {
    this.usePreviousSourceParameters = usePreviousSourceParameters;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RefreshConnectionDto refreshConnectionDto = (RefreshConnectionDto) o;
    return Objects.equals(this.connectionId, refreshConnectionDto.connectionId) &&
        Objects.equals(this.destinationParameters, refreshConnectionDto.destinationParameters) &&
        Objects.equals(this.sourceParameters, refreshConnectionDto.sourceParameters) &&
        Objects.equals(this.usePreviousDestinationParameters, refreshConnectionDto.usePreviousDestinationParameters) &&
        Objects.equals(this.usePreviousSourceParameters, refreshConnectionDto.usePreviousSourceParameters);
  }

  @Override
  public int hashCode() {
    return Objects.hash(connectionId, destinationParameters, sourceParameters, usePreviousDestinationParameters, usePreviousSourceParameters);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RefreshConnectionDto {\n");
    
    sb.append("    connectionId: ").append(toIndentedString(connectionId)).append("\n");
    sb.append("    destinationParameters: ").append(toIndentedString(destinationParameters)).append("\n");
    sb.append("    sourceParameters: ").append(toIndentedString(sourceParameters)).append("\n");
    sb.append("    usePreviousDestinationParameters: ").append(toIndentedString(usePreviousDestinationParameters)).append("\n");
    sb.append("    usePreviousSourceParameters: ").append(toIndentedString(usePreviousSourceParameters)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

