/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import org.joda.time.DateTime;


/**
 * SelectListDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class SelectListDto   {
  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("name")
  private String name = null;

  /**
   * This is currently not used and its value will always be 'static'. In the future, more types will be added.
   */
  public enum TypeEnum {
    @SerializedName("static")
    STATIC("static");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("type")
  private TypeEnum type = null;

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("userId")
  private String userId = null;

  /**
   * Defines the type of the items in the list.
   */
  public enum ValueTypeEnum {
    @SerializedName("string")
    STRING("string"),
    
    @SerializedName("bytes")
    BYTES("bytes"),
    
    @SerializedName("integer")
    INTEGER("integer"),
    
    @SerializedName("float")
    FLOAT("float"),
    
    @SerializedName("boolean")
    BOOLEAN("boolean"),
    
    @SerializedName("timestamp")
    TIMESTAMP("timestamp"),
    
    @SerializedName("date")
    DATE("date"),
    
    @SerializedName("time")
    TIME("time"),
    
    @SerializedName("datetime")
    DATETIME("datetime"),
    
    @SerializedName("global_parameter")
    GLOBAL_PARAMETER("global_parameter"),
    
    @SerializedName("nested_query_parameter")
    NESTED_QUERY_PARAMETER("nested_query_parameter");

    private String value;

    ValueTypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("valueType")
  private ValueTypeEnum valueType = null;

  @SerializedName("values")
  private List<Object> values = new ArrayList<Object>();

  @SerializedName("version")
  private Long version = null;

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

  public SelectListDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of this select list. Max length: 1024
   * @return description
  **/
  @ApiModelProperty(example = "null", value = "Description of this select list. Max length: 1024")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * The entity's unique identifier
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier")
  public String getId() {
    return id;
  }

  public SelectListDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of this select list. Max length: 100
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "Name of this select list. Max length: 100")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

   /**
   * This is currently not used and its value will always be 'static'. In the future, more types will be added.
   * @return type
  **/
  @ApiModelProperty(example = "null", value = "This is currently not used and its value will always be 'static'. In the future, more types will be added.")
  public TypeEnum getType() {
    return type;
  }

   /**
   * When the entity was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the entity was last updated")
  public DateTime getUpdated() {
    return updated;
  }

   /**
   * The owner of the entity
   * @return userId
  **/
  @ApiModelProperty(example = "null", value = "The owner of the entity")
  public String getUserId() {
    return userId;
  }

  public SelectListDto valueType(ValueTypeEnum valueType) {
    this.valueType = valueType;
    return this;
  }

   /**
   * Defines the type of the items in the list.
   * @return valueType
  **/
  @ApiModelProperty(example = "null", value = "Defines the type of the items in the list.")
  public ValueTypeEnum getValueType() {
    return valueType;
  }

  public void setValueType(ValueTypeEnum valueType) {
    this.valueType = valueType;
  }

  public SelectListDto values(List<Object> values) {
    this.values = values;
    return this;
  }

  public SelectListDto addValuesItem(Object valuesItem) {
    this.values.add(valuesItem);
    return this;
  }

   /**
   * List of possible values for the list. These values will be validated against the valueType provided.
   * @return values
  **/
  @ApiModelProperty(example = "null", value = "List of possible values for the list. These values will be validated against the valueType provided.")
  public List<Object> getValues() {
    return values;
  }

  public void setValues(List<Object> values) {
    this.values = values;
  }

   /**
   * The version of the current representation of the entity
   * @return version
  **/
  @ApiModelProperty(example = "null", value = "The version of the current representation of the entity")
  public Long getVersion() {
    return version;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SelectListDto selectListDto = (SelectListDto) o;
    return Objects.equals(this.created, selectListDto.created) &&
        Objects.equals(this.description, selectListDto.description) &&
        Objects.equals(this.id, selectListDto.id) &&
        Objects.equals(this.name, selectListDto.name) &&
        Objects.equals(this.type, selectListDto.type) &&
        Objects.equals(this.updated, selectListDto.updated) &&
        Objects.equals(this.userId, selectListDto.userId) &&
        Objects.equals(this.valueType, selectListDto.valueType) &&
        Objects.equals(this.values, selectListDto.values) &&
        Objects.equals(this.version, selectListDto.version);
  }

  @Override
  public int hashCode() {
    return Objects.hash(created, description, id, name, type, updated, userId, valueType, values, version);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SelectListDto {\n");
    
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    valueType: ").append(toIndentedString(valueType)).append("\n");
    sb.append("    values: ").append(toIndentedString(values)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

