/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.TableDto;
import org.joda.time.DateTime;


/**
 * SharedTableDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class SharedTableDto   {
  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("destinationWorkspaceId")
  private String destinationWorkspaceId = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("parentId")
  private String parentId = null;

  @SerializedName("sourceTableId")
  private String sourceTableId = null;

  @SerializedName("table")
  private TableDto table = null;

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("userId")
  private String userId = null;

  @SerializedName("version")
  private Long version = null;

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

  public SharedTableDto destinationWorkspaceId(String destinationWorkspaceId) {
    this.destinationWorkspaceId = destinationWorkspaceId;
    return this;
  }

   /**
   * The id of the workspace being shared to.
   * @return destinationWorkspaceId
  **/
  @ApiModelProperty(example = "null", required = true, value = "The id of the workspace being shared to.")
  public String getDestinationWorkspaceId() {
    return destinationWorkspaceId;
  }

  public void setDestinationWorkspaceId(String destinationWorkspaceId) {
    this.destinationWorkspaceId = destinationWorkspaceId;
  }

   /**
   * The entity's unique identifier
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier")
  public String getId() {
    return id;
  }

   /**
   * If non-null, indicates the parent of this entity. Must be modified through the folder api.
   * @return parentId
  **/
  @ApiModelProperty(example = "null", value = "If non-null, indicates the parent of this entity. Must be modified through the folder api.")
  public String getParentId() {
    return parentId;
  }

  public SharedTableDto sourceTableId(String sourceTableId) {
    this.sourceTableId = sourceTableId;
    return this;
  }

   /**
   * The id of the table being shared.
   * @return sourceTableId
  **/
  @ApiModelProperty(example = "null", required = true, value = "The id of the table being shared.")
  public String getSourceTableId() {
    return sourceTableId;
  }

  public void setSourceTableId(String sourceTableId) {
    this.sourceTableId = sourceTableId;
  }

  public SharedTableDto table(TableDto table) {
    this.table = table;
    return this;
  }

   /**
   * The associated table which will be hydrated when listing are fetching shared table entities.
   * @return table
  **/
  @ApiModelProperty(example = "null", value = "The associated table which will be hydrated when listing are fetching shared table entities.")
  public TableDto getTable() {
    return table;
  }

  public void setTable(TableDto table) {
    this.table = table;
  }

   /**
   * When the entity was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the entity was last updated")
  public DateTime getUpdated() {
    return updated;
  }

   /**
   * The owner of the entity
   * @return userId
  **/
  @ApiModelProperty(example = "null", value = "The owner of the entity")
  public String getUserId() {
    return userId;
  }

   /**
   * The version of the current representation of the entity
   * @return version
  **/
  @ApiModelProperty(example = "null", value = "The version of the current representation of the entity")
  public Long getVersion() {
    return version;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SharedTableDto sharedTableDto = (SharedTableDto) o;
    return Objects.equals(this.created, sharedTableDto.created) &&
        Objects.equals(this.destinationWorkspaceId, sharedTableDto.destinationWorkspaceId) &&
        Objects.equals(this.id, sharedTableDto.id) &&
        Objects.equals(this.parentId, sharedTableDto.parentId) &&
        Objects.equals(this.sourceTableId, sharedTableDto.sourceTableId) &&
        Objects.equals(this.table, sharedTableDto.table) &&
        Objects.equals(this.updated, sharedTableDto.updated) &&
        Objects.equals(this.userId, sharedTableDto.userId) &&
        Objects.equals(this.version, sharedTableDto.version);
  }

  @Override
  public int hashCode() {
    return Objects.hash(created, destinationWorkspaceId, id, parentId, sourceTableId, table, updated, userId, version);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SharedTableDto {\n");
    
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    destinationWorkspaceId: ").append(toIndentedString(destinationWorkspaceId)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    parentId: ").append(toIndentedString(parentId)).append("\n");
    sb.append("    sourceTableId: ").append(toIndentedString(sourceTableId)).append("\n");
    sb.append("    table: ").append(toIndentedString(table)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

