/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * UniqueConstraintDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class UniqueConstraintDto   {
  @SerializedName("description")
  private String description = null;

  @SerializedName("id")
  private String id = null;

  /**
   * Name of this unique constraint. Max length: 100
   */
  public enum NameEnum {
    @SerializedName("key_columns")
    COLUMNS("key_columns");

    private String value;

    NameEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("name")
  private NameEnum name = null;

  @SerializedName("tableId")
  private String tableId = null;

  @SerializedName("values")
  private List<String> values = new ArrayList<String>();

  public UniqueConstraintDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of this unique constraint. Max length: 1024
   * @return description
  **/
  @ApiModelProperty(example = "null", value = "Description of this unique constraint. Max length: 1024")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public UniqueConstraintDto id(String id) {
    this.id = id;
    return this;
  }

   /**
   * Id of the unique constraint
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "Id of the unique constraint")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public UniqueConstraintDto name(NameEnum name) {
    this.name = name;
    return this;
  }

   /**
   * Name of this unique constraint. Max length: 100
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "Name of this unique constraint. Max length: 100")
  public NameEnum getName() {
    return name;
  }

  public void setName(NameEnum name) {
    this.name = name;
  }

  public UniqueConstraintDto tableId(String tableId) {
    this.tableId = tableId;
    return this;
  }

   /**
   * Id of the table this unique constraint is associated with
   * @return tableId
  **/
  @ApiModelProperty(example = "null", value = "Id of the table this unique constraint is associated with")
  public String getTableId() {
    return tableId;
  }

  public void setTableId(String tableId) {
    this.tableId = tableId;
  }

  public UniqueConstraintDto values(List<String> values) {
    this.values = values;
    return this;
  }

  public UniqueConstraintDto addValuesItem(String valuesItem) {
    this.values.add(valuesItem);
    return this;
  }

   /**
   * List of values in the unique constraint
   * @return values
  **/
  @ApiModelProperty(example = "null", value = "List of values in the unique constraint")
  public List<String> getValues() {
    return values;
  }

  public void setValues(List<String> values) {
    this.values = values;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UniqueConstraintDto uniqueConstraintDto = (UniqueConstraintDto) o;
    return Objects.equals(this.description, uniqueConstraintDto.description) &&
        Objects.equals(this.id, uniqueConstraintDto.id) &&
        Objects.equals(this.name, uniqueConstraintDto.name) &&
        Objects.equals(this.tableId, uniqueConstraintDto.tableId) &&
        Objects.equals(this.values, uniqueConstraintDto.values);
  }

  @Override
  public int hashCode() {
    return Objects.hash(description, id, name, tableId, values);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UniqueConstraintDto {\n");
    
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    tableId: ").append(toIndentedString(tableId)).append("\n");
    sb.append("    values: ").append(toIndentedString(values)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

