/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.TableDto;
import java.util.ArrayList;
import java.util.List;


/**
 * ValidateTablesDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-01-27T22:58:16.131Z")
public class ValidateTablesDto   {
  @SerializedName("deletedTables")
  private List<TableDto> deletedTables = new ArrayList<TableDto>();

  @SerializedName("repairedTables")
  private List<TableDto> repairedTables = new ArrayList<TableDto>();

  public ValidateTablesDto deletedTables(List<TableDto> deletedTables) {
    this.deletedTables = deletedTables;
    return this;
  }

  public ValidateTablesDto addDeletedTablesItem(TableDto deletedTablesItem) {
    this.deletedTables.add(deletedTablesItem);
    return this;
  }

   /**
   * A list of tables that were deleted during the validation because not enough information was available to repair them. These tables will no longer be available via the endpoint and queries using these tables will cease to function properly.
   * @return deletedTables
  **/
  @ApiModelProperty(example = "null", value = "A list of tables that were deleted during the validation because not enough information was available to repair them. These tables will no longer be available via the endpoint and queries using these tables will cease to function properly.")
  public List<TableDto> getDeletedTables() {
    return deletedTables;
  }

  public void setDeletedTables(List<TableDto> deletedTables) {
    this.deletedTables = deletedTables;
  }

  public ValidateTablesDto repairedTables(List<TableDto> repairedTables) {
    this.repairedTables = repairedTables;
    return this;
  }

  public ValidateTablesDto addRepairedTablesItem(TableDto repairedTablesItem) {
    this.repairedTables.add(repairedTablesItem);
    return this;
  }

   /**
   * A list of tables that were modified during the validation and will continue to be visible and to be usable in the account.
   * @return repairedTables
  **/
  @ApiModelProperty(example = "null", value = "A list of tables that were modified during the validation and will continue to be visible and to be usable in the account.")
  public List<TableDto> getRepairedTables() {
    return repairedTables;
  }

  public void setRepairedTables(List<TableDto> repairedTables) {
    this.repairedTables = repairedTables;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ValidateTablesDto validateTablesDto = (ValidateTablesDto) o;
    return Objects.equals(this.deletedTables, validateTablesDto.deletedTables) &&
        Objects.equals(this.repairedTables, validateTablesDto.repairedTables);
  }

  @Override
  public int hashCode() {
    return Objects.hash(deletedTables, repairedTables);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ValidateTablesDto {\n");
    
    sb.append("    deletedTables: ").append(toIndentedString(deletedTables)).append("\n");
    sb.append("    repairedTables: ").append(toIndentedString(repairedTables)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

