/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.BaseResponseOfConnectionDto;
import io.swagger.client.model.BaseResponseOfRefreshBatchDto;
import io.swagger.client.model.BaseResponseOfConnectionRunDto;
import io.swagger.client.model.PagedResponseOfConnectionDto;
import io.swagger.client.model.RefreshConnectionDto;
import org.junit.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ConnectionManagementApi
 */
public class ConnectionManagementApiTest {

    private final ConnectionManagementApi api = new ConnectionManagementApi();

    
    /**
     * Get connection details
     *
     * Returns details about a specific connection, based on its ID
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getConnectionUsingGETTest() throws ApiException {
        String connectionId = null;
        // BaseResponseOfConnectionDto response = api.getConnectionUsingGET(connectionId);

        // TODO: test validations
    }
    
    /**
     * Gets the status of a batch refresh
     *
     * Returns details about a specific batch refresh, based on its ID.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getRefreshBatchStatusUsingGETTest() throws ApiException {
        String batchId = null;
        // BaseResponseOfRefreshBatchDto response = api.getRefreshBatchStatusUsingGET(batchId);

        // TODO: test validations
    }
    
    /**
     * Get connection refresh status
     *
     * Returns details about a specific connection refresh status, based on its ID. To retrieve details about a specific refresh, provide its &#39;jobId&#39;.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getRefreshStatusUsingGETTest() throws ApiException {
        String connectionId = null;
        String jobId = null;
        // BaseResponseOfConnectionRunDto response = api.getRefreshStatusUsingGET(connectionId, jobId);

        // TODO: test validations
    }
    
    /**
     * List connections
     *
     * A pageable endpoint to list data connections between features of the Workiva platform
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listConnectionsUsingGETTest() throws ApiException {
        String sourceType = null;
        String destinationType = null;
        String sourceId = null;
        String destinationId = null;
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfConnectionDto response = api.listConnectionsUsingGET(sourceType, destinationType, sourceId, destinationId, limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Refresh batch of connections
     *
     * Refreshes multiple connections at once, based on their IDs
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void refreshBatchUsingPOSTTest() throws ApiException {
        List<RefreshConnectionDto> refreshConnectionDtos = null;
        // BaseResponseOfRefreshBatchDto response = api.refreshBatchUsingPOST(refreshConnectionDtos);

        // TODO: test validations
    }
    
    /**
     * Refresh connection
     *
     * Refreshes a specific connection, based on its ID
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void refreshConnectionUsingPOSTTest() throws ApiException {
        String connectionId = null;
        RefreshConnectionDto refreshConnectionDto = null;
        // BaseResponseOfConnectionRunDto response = api.refreshConnectionUsingPOST(connectionId, refreshConnectionDto);

        // TODO: test validations
    }
    
}
