/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.MultiError;
import io.swagger.client.model.BaseResponseOfSpreadsheetInfoDto;
import io.swagger.client.model.ExportFileDto;
import io.swagger.client.model.PagedResponseOfImportErrorDto;
import io.swagger.client.model.BaseResponseOfFileMetaDto;
import io.swagger.client.model.PagedResponseOfFileMetaDto;
import java.io.File;
import org.junit.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for FileManagementApi
 */
public class FileManagementApiTest {

    private final FileManagementApi api = new FileManagementApi();

    
    /**
     * Delete a single file
     *
     * Unstages the file with the provided ID. The file must have a STAGED status; if the file isn&#39;t STAGED, returns a 409 status. If the file isn&#39;t found, this is a no-op.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteFileUsingDELETETest() throws ApiException {
        String fileId = null;
        // BaseResponseOfstring response = api.deleteFileUsingDELETE(fileId);

        // TODO: test validations
    }
    
    /**
     * Download a single file
     *
     * Returns a file with the provided ID, which points to a file meta ID.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void downloadFileUsingGETTest() throws ApiException {
        String fileId = null;
        // byte[] response = api.downloadFileUsingGET(fileId);

        // TODO: test validations
    }
    
    /**
     * Export a file to spreadsheets
     *
     * Exports the file ID identified in the path to the spreadsheet identified by the provided URL. If the URL string is empty, creates and returns a new spreadsheet and its sheet IDs.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void exportFileToSpreadsheetsUsingPOSTTest() throws ApiException {
        String fileId = null;
        ExportFileDto exportFileDto = null;
        // BaseResponseOfSpreadsheetInfoDto response = api.exportFileToSpreadsheetsUsingPOST(fileId, exportFileDto);

        // TODO: test validations
    }
    
    /**
     * Retrieve errors
     *
     * Returns a paged list of operation errors during the upload, import, or tagging processes for the provided file ID, if they exist. This list is immutable and may be empty if no errors have occurred. If errors exist we recommend fixing them and reimporting your file
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getErrorsUsingGETTest() throws ApiException {
        String fileId = null;
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfImportErrorDto response = api.getErrorsUsingGET(fileId, limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Retrieve a single file
     *
     * Returns the file meta that matches the provided ID, or a 404 if an associated file can&#39;t be found.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getFileUsingGETTest() throws ApiException {
        String fileId = null;
        // BaseResponseOfFileMetaDto response = api.getFileUsingGET(fileId);

        // TODO: test validations
    }
    
    /**
     * Retrieve a list of files
     *
     * Returns a paged list of all files associated with the provided table ID, as well as metadata associated with each file.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getFilesUsingGETTest() throws ApiException {
        String tableId = null;
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        String sortOrder = null;
        String sortBy = null;
        String searchText = null;
        // PagedResponseOfFileMetaDto response = api.getFilesUsingGET(tableId, limit, cursor, offset, sortOrder, sortBy, searchText);

        // TODO: test validations
    }
    
    /**
     * Upload a single file
     *
     * Accepts CSV, TSV, or JSON files, or a ZIP file that contains a single CSV, TSV, or JSON file. If a ZIP, it must contain a CSV, TSV, or JSON file, and the name of the CSV, TSV, or JSON file is also used with the imported file. Downloading this file again downloads the source. Note that all files uploaded must have a .csv, .tsv, or .json extension. JSON files are expected to have a single JSON record per line; a JSON file is a series of JSON objects delimited by a newline character.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void uploadFileUsingPOSTTest() throws ApiException {
        String tableId = null;
        File file = null;
        String name = null;
        String url = null;
        String source = null;
        String delimiter = null;
        // BaseResponseOfFileMetaDto response = api.uploadFileUsingPOST(tableId, file, name, url, source, delimiter);

        // TODO: test validations
    }
    
    /**
     * Validate whether a file with the filename can be uploaded to the table
     *
     * If the filename is valid, this returns 200. If the table already has a file with the same name, this returns 409. If the user isn&#39;t allowed to read the table, or if the table isn&#39;t found, this returns 404.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void validateFilenameUsingGETTest() throws ApiException {
        String tableId = null;
        String filename = null;
        // BaseResponseOfstring response = api.validateFilenameUsingGET(tableId, filename);

        // TODO: test validations
    }
    
}
